Bug 23140 - More languages need two forms of month names
Summary: More languages need two forms of month names
Status: RESOLVED FIXED
Alias: None
Product: glibc
Classification: Unclassified
Component: localedata (show other bugs)
Version: 2.27
: P2 normal
Target Milestone: 2.28
Assignee: Not yet assigned to anyone
URL:
Keywords:
Depends on:
Blocks:
 
Reported: 2018-05-04 20:55 IST by Rafal Luzynski
Modified: 2018-08-01 05:51 IST (History)
7 users (show)

See Also:
Host:
Target:
Build:
Last reconfirmed:
fweimer: security-


Attachments
Asturian (ast_ES) (703 bytes, patch)
2018-05-11 09:44 IST, Rafal Luzynski
Details | Diff
Kashubian (csb_PL) (690 bytes, patch)
2018-05-11 09:45 IST, Rafal Luzynski
Details | Diff
Finnish (fi_FI) (651 bytes, patch)
2018-05-11 09:48 IST, Rafal Luzynski
Details | Diff
Scottish Gaelic (gd_GB) (772 bytes, patch)
2018-05-11 09:52 IST, Rafal Luzynski
Details | Diff
Upper Sorbian (hsb_DE) (607 bytes, patch)
2018-05-11 09:53 IST, Rafal Luzynski
Details | Diff
Ossetian (os_RU) (653 bytes, patch)
2018-05-11 09:56 IST, Rafal Luzynski
Details | Diff
Slovak (sk_SK) (622 bytes, patch)
2018-05-11 10:00 IST, Rafal Luzynski
Details | Diff
Walloon (wa_BE) (850 bytes, patch)
2018-05-11 10:03 IST, Rafal Luzynski
Details | Diff
Occitan (oc_FR) (1.17 KB, patch)
2018-05-17 23:24 IST, Rafal Luzynski
Details | Diff
Kashubian (csb_PL) version 2 (692 bytes, patch)
2018-06-06 23:56 IST, Rafal Luzynski
Details | Diff
Walloon (wa_BE) version 2 (990 bytes, patch)
2018-06-06 23:58 IST, Rafal Luzynski
Details | Diff
Armenian (hy_AM) (727 bytes, patch)
2018-06-12 20:53 IST, Rafal Luzynski
Details | Diff
Kashubian (csb_PL) version 3 (1011 bytes, patch)
2018-06-21 10:53 IST, Rafal Luzynski
Details | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Rafal Luzynski 2018-05-04 20:55:44 IST
The aim of this bug report is to gather the changes for all languages which need two forms of month names.  As a result of fixing the bug 10871 this feature is now supported by glibc but originally the locale data for only 7 languages have been updated (Belarusian, Croatian, Greek, Lithuanian, Polish, Russian, Ukrainian) followed by two more: Catalan (bug 22848) and Czech (bug 22963).  Here is a more complete list of languages which need update or at least an attention:

* Asturian,
* Finnish (most probably the local community does not want this because a workaround exists and has been adapted),
* Kashubian,
* Lower Sorbian (currently not supported by glibc, either its support is added to glibc first or please ignore this entry),
* Occitan (new in this list),
* Ossetian,
* Scottish Gaelic,
* Serbian (must be discussed with the local community),
* Silesian (not supported by CLDR, I have no reliable source of locale data),
* Slovak (must be discussed with the local community),
* Upper Sorbian,
* Walloon.

The list can be extended by the languages which do not need two grammatical forms but want to use this feature to begin the month names with upper or lower case letter depending on whether they are standalone or in full date context.  CLDR provides such data for 13 locales.
Comment 1 Rafal Luzynski 2018-05-04 20:56:35 IST
s/adapted/adopted
Comment 2 Egmont Koblinger 2018-05-04 21:11:51 IST
(In reply to Rafal Luzynski from comment #0)

> The list can be extended by the languages which do not need two grammatical
> forms but want to use this feature to begin the month names with upper or
> lower case letter [...]

Could we pretty please have a different notation for this?

Languages that do have different nominative and genitive forms might also want to have lowercase and uppercase variants (for both kinds), why not allow it for them too? 

If the same syntax is overloaded, how could any piece of software safely decide whether to use %B or %OB (or: %b or %Ob) and be sure that it's going to be okay? You'd need to pick one based on the characteristics of the language, based on the meaning of the "O" modifier for that particular language, which is practically a no-go.

Plus, by the way, lowercase/uppercase variants might be relevant for the AM/PM strings as well.

Different semantics should be achieved using a different syntax.

Thanks!
Comment 3 Rafal Luzynski 2018-05-04 22:10:51 IST
I absolutely agree.  This idea is already reflected in these bug reports:

* bug 21370: introduce a "convert to titlecase" flag;
* bug 15527: make the combination of existing flags "^#" work correctly and convert to lowercase;
* optionally: specify that all locale data must be titlecased and convert them to all uppercase/all lowercase only on an explicit demand.

Providing the upper/lowercase variant would be meant only as a workaround or a temporary solution; also it is suggested by CLDR as a good use of the software feature which is actually used by only a minority of languages.
Comment 4 Michael Bauer 2018-05-05 10:28:25 IST
This applies to Scottish Gaelic indeed (gd-GB) but they're not genitives though, they're partitives - and I think other languages will be using other grammatical patterns too, so perhaps the naming should be more general, like "inflected month name" rather than genitive?

Anyway, starting with January, the inflected forms are as follows:

dhen Fhaoilleach
dhen Ghearran
dhen Mhàrt
dhen Ghiblean
dhen Chèitean
dhen Ògmhios
dhen Iuchar
dhen Lùnastal
dhen t-Sultain
dhen Dàmhair
dhen t-Samhain
dhen Dùbhlachd
Comment 5 Michael Wolf 2018-05-05 13:15:57 IST
Upper Sorbian:

Nominative             Accusative                Genitive

januar                 januar                    januara
februar                februar                   februar
měrc                   měrc                      měrca
apryl                  apryl                     apryla
meja                   meju                      meje
junij                  junij                     junija
julij                  julij                     julija
awgust                 awgust                    awgusta
september              september                 septembra
oktober                oktober                   oktobra
nowember               nowember                  nowembra
december               december                  decembra

Meja "May" is an exceptional case: It is the only month name that has feminine gender. Therefore its nominative and accusative are not identical. Besides it has the ending -e in genitive instead of -a. With the month names for september, oktober, nowember and december, the vowel "e" is elided before the consonant "r".

Lower Sorbian:

Nominative             Accusative                Genitive

januar                 januar                    januara
februar                februar                   februar
měrc                   měrc                      měrca
apryl                  apryl                     apryla
maj                    maj                       maja
junij                  junij                     junija
julij                  julij                     julija
awgust                 awgust                    awgusta
september              september                 septembra
oktober                oktober                   oktobra
nowember               nowember                  nowembra
december               december                  decembra

The most Lower Sorbian month names are identical to the Upper Sorbian ones with one exception: maj "May". Maj is masculine and therefore nominative and accusative are identical here. The Upper Sorbian exceptional case does not exist in Lower Sorbian.

There is a fourth grammatical case that often occurs: The locative. It mainly occurs behind the preposition w "in":

w januarje "in January"
w februarje "in February"
w měrcu "in March"
w aprylu "in April"
w meji (Upper Sorbian), w maju (Lower Sorbian) "in May"
w juniju "in June"
w juliju "in July"
w awgusće "in August"
w septembrje "in September"
w oktobrje "in October"
w nowembrje "in November"
w decembrje "in December"
Comment 6 Michael Wolf 2018-05-05 13:22:11 IST
Sorry, a typo: The genitive of "februar" must be "februara", of course, both for Upper Sorbian and Lower Sorbian.
Comment 7 Rafal Luzynski 2018-05-05 18:03:59 IST
(In reply to Michael Bauer from comment #4)
> This applies to Scottish Gaelic indeed (gd-GB) but they're not genitives
> though, they're partitives - and I think other languages will be using other
> grammatical patterns too, so perhaps the naming should be more general, like
> "inflected month name" rather than genitive?

Thank you for this update. The documentation never uses the term "genitive" nor "nominative". I often use the term "genitive" because: (1) it is shorter than "a  form used when the month name forms part of the date"; (2) so far I have not known about any language which requires other case than genitive; (3) a genitive case is a good example of a form required to format a date.

> Anyway, starting with January, the inflected forms are as follows:
> [ cut ]

Thank you. This is already provided by CLDR and I have patches ready for Scottish Gaelic and several other languages as well. I am going to attach them in the beginning of the next week. I will appreciate a final review, though.


(In reply to Michael Wolf from comment #5)
> Upper Sorbian:
> 
> Nominative             Accusative                Genitive
> [...]

Thank you. Unfortunately, we are unable to support more than 2 cases. This is a minimum required to format a date. I guess that the correct case for Upper Sorbian when formatting a date is genitive. Supporting more cases is a task for a natural language translating and processing tool, not for strftime() function from glibc. Again, I have a patch for the Upper Sorbian and I am going to attach it next week.

> Meja "May" is an exceptional case: It is the only month name that has
> feminine gender. Therefore its nominative and accusative are not identical.
> Besides it has the ending -e in genitive instead of -a.

That's very interesting, thank you.

> With the month names
> for september, oktober, nowember and december, the vowel "e" is elided
> before the consonant "r".

OK, I am familiar with these phenomenons because they are the same in my native language.

> Lower Sorbian:
> 
> Nominative             Accusative                Genitive
> [...]

As I said above, Lower Sorbian is not supported by glibc. I'll be happy to add it, though, especially since I see it supported by CLDR. Can you please open a separate ticket and (even better) provide a patch? If you can't then tell me so I will do it but I will need an assistance to complete the task.

> [...]
> There is a fourth grammatical case that often occurs: The locative. It
> mainly occurs behind the preposition w "in":
> 
> w januarje "in January"
> [...]

As I said above, we can't support more than two cases. This would be useful to generate natural language sentences and maybe in some more applications but it is not absolutely necessary for strftime() function to display dates correctly.
Comment 8 Michael Wolf 2018-05-05 19:13:32 IST
Hi Rafał,

thank you for your reply.

Well, you are right, Sorbian languages use the month names in genitive in dates if the day is specified:

Dźensa je 05. meje 2018. (Upper Sorbian)
Źinsa jo 05. maja 2018. (Lower Sorbian)
Today is 5th May, 2018.

Locative is always used with prepositions. There would be a problem only if month name placeholders are used because placeholders cannot be inflected. Strftime() uses such placeholders: %d. %B %Y. %B cannot be inflected so "w %B" would result in "w meja" instead in correct "w meji". 

Another problem would occur if any software is intended to use the OS locale for date and time. There is no operating system in Sorbian languages until now. That's a problem of many minority languages.
Comment 9 Rafal Luzynski 2018-05-05 21:31:46 IST
(In reply to Michael Wolf from comment #8)
> Hi Rafał,
> 
> thank you for your reply.
> 
> Well, you are right, Sorbian languages use the month names in genitive in
> dates if the day is specified:
> [ cut ]

OK, count them as about to be supported.

> [...]
> Strftime() uses such placeholders: %d. %B %Y. %B cannot be inflected so "w
> %B" would result in "w meja" instead in correct "w meji". 

True, this is not supported. But please note that this is a sentence, or almost a sentence rather than just a date. This does not work in any inflected language. We need a place where we say "this is too complex for glibc, please use a translation software or an AI instead". :-)

> Another problem would occur if any software is intended to use the OS locale
> for date and time. There is no operating system in Sorbian languages until
> now. That's a problem of many minority languages.

You are just invited to create one. :-) Really not much is left to do. In fact, HSB has been supported in glibc for a long time now except this bug with a correct grammar of dates.
Comment 10 Rafal Luzynski 2018-05-11 09:19:28 IST
(In reply to Michael Wolf from comment #5)
> Upper Sorbian:
> 
> Nominative             Accusative                Genitive
> 
> januar                 januar                    januara
> februar                februar                   februar
> [...]

Shouldn't the genitive case be "februara"?

http://st.unicode.org/cldr-apps/v#/hsb/Gregorian/

And the same in Lower Sorbian.
Comment 11 Rafal Luzynski 2018-05-11 09:44:29 IST
Created attachment 11003 [details]
Asturian (ast_ES)

Here I include a set of patches for easier review by the respective language teams. I think that eventually all (or almost all) of these patches will be squashed and pushed together unless we get a negative feedback. I'd like to push them in a month. Also they can be pushed individually earlier if a language team wishes. Unfortunately, I suspect that for some of these languages it will be difficult to reach actual translators.
Comment 12 Rafal Luzynski 2018-05-11 09:45:46 IST
Created attachment 11004 [details]
Kashubian (csb_PL)

This is not supported by CLDR, I collected the data from Wikipedia.
Comment 13 Michael Wolf 2018-05-11 09:46:07 IST
Hi Rafał,

thanks, yes, you are right, I wrote (and copied) februar first :-( but I've already corrected it in comment #6. :-)
Comment 14 Rafal Luzynski 2018-05-11 09:48:50 IST
Created attachment 11005 [details]
Finnish (fi_FI)

I think we have sufficient negative feedback for this language (i.e., the native speakers don't want this change) but here I attach it for the last chance in case they change their minds. The reason is that the inflection rule in Finnish language is simple: append "ta" at the end of every month name and we get a correct genitive case. This is a currently used workaround.
Comment 15 Rafal Luzynski 2018-05-11 09:52:13 IST
Created attachment 11006 [details]
Scottish Gaelic (gd_GB)

I think we have a sufficient positive feedback and a very responsive language team. If you wish the patch to be committed now and reach the prerelease distros (like Fedora Rawhide) then please say. Otherwise it will be committed in a month.
Comment 16 Rafal Luzynski 2018-05-11 09:53:59 IST
Created attachment 11007 [details]
Upper Sorbian (hsb_DE)

The same case here.
Comment 17 Rafal Luzynski 2018-05-11 09:56:27 IST
Created attachment 11008 [details]
Ossetian (os_RU)

Decoded:

diff --git a/localedata/locales/os_RU b/localedata/locales/os_RU
index fcd72ef..9a4ce03 100644
--- a/localedata/locales/os_RU
+++ b/localedata/locales/os_RU
@@ -116,7 +116,7 @@ abmon   "Янв";/
 "Ноя";/
 "Дек"
 
-mon     "Январь";/
+alt_mon "Январь";/
 "Февраль";/
 "Мартъи";/
 "Апрель";/
@@ -128,6 +128,19 @@ mon     "Январь";/
 "Октябрь";/
 "Ноябрь";/
 "Декабрь"
+
+mon     "январы";/
+"февралы";/
+"мартъийы";/
+"апрелы";/
+"майы";/
+"июны";/
+"июлы";/
+"августы";/
+"сентябры";/
+"октябры";/
+"ноябры";/
+"декабры"
 d_t_fmt "%a %d %b %Y %T"
 d_fmt     "%d.%m.%Y"
 t_fmt     "%T"
-- 
2.7.5
Comment 18 Rafal Luzynski 2018-05-11 10:00:39 IST
Created attachment 11009 [details]
Slovak (sk_SK)

This change is controversial (same as Czech and Serbian) because, as far as I understand the grammar rules, while a genitive case of a month name is sometimes required the normal date format is day_number + ". " + month_name_nominative. I will not commit without a positive feedback from the language team. However, I hope the change will be useful and I offer my help when adopting it.
Comment 19 Rafal Luzynski 2018-05-11 10:03:46 IST
Created attachment 11010 [details]
Walloon (wa_BE)

The support of this language in CLDR is very incomplete [1] but I've reconstructed the content thanks to Wikipedia and the original comments inside the file which already contained complaints about this missing feature.

[1] http://st.unicode.org/cldr-apps/v#/wa/Gregorian/
Comment 20 Rafal Luzynski 2018-05-17 23:24:00 IST
Created attachment 11025 [details]
Occitan (oc_FR)

I've just received this recently.
Comment 21 Soslan Khubulov 2018-05-21 18:11:22 IST
(In reply to Rafal Luzynski from comment #17)
> Created attachment 11008 [details]
> Ossetian (os_RU)

Grammar is correct, but it would be better to capitalize alt_mon strings too for consistency.
Comment 22 Michael Wolf 2018-05-21 19:58:11 IST
Lower Sorbian can be ignored by this bug now. Meanwhile bug 23208 exists with the complete new locale file dsb_DE which already contains the genitive month names for dates.
Comment 23 Rafal Luzynski 2018-05-22 22:54:46 IST
(In reply to Soslan Khubulov from comment #21)
> (In reply to Rafal Luzynski from comment #17)
> > Created attachment 11008 [details]
> > Ossetian (os_RU)
> 
> Grammar is correct, but it would be better to capitalize alt_mon strings too
> for consistency.

Thank you for your review. alt_mon is currently capitalized in this patch. Did you mean anything different?

BTW, what do you think about abbreviated month names? Currently in glibc we have all Ossetian month names abbreviated to 3 letters. CLDR [1] provides 3-4 letters plus a dot unless whole word is 3 or 4 letters long. As a consequence some "abbreviated" month names have their inflection visible: "Май" -> "майы", "Июнь" -> "июны" and so on. Also, the abbreviated standalone (nominative?) forms are all capitalized.

[1] http://st.unicode.org/cldr-apps/v#/os/Gregorian/

While at this, what is the correct English name: Ossetian (Wikipedia says so) or Ossetic (CLDR says so)?
Comment 24 Soslan Khubulov 2018-05-24 10:08:07 IST
(In reply to Rafal Luzynski from comment #23)
> Thank you for your review. alt_mon is currently capitalized in this patch.
> Did you mean anything different?

I meant mon. Sorry for that.

> BTW, what do you think about abbreviated month names? Currently in glibc we
> have all Ossetian month names abbreviated to 3 letters. CLDR [1] provides
> 3-4 letters plus a dot unless whole word is 3 or 4 letters long. As a
> consequence some "abbreviated" month names have their inflection visible:
> "Май" -> "майы", "Июнь" -> "июны" and so on. Also, the abbreviated
> standalone (nominative?) forms are all capitalized.

I think consistency is more important. If other locales in glibc use 3 letter abbreviations then Ossetian locale should use 3 letters too. As for usability, both styles are equally recognizable.
 
> While at this, what is the correct English name: Ossetian (Wikipedia says
> so) or Ossetic (CLDR says so)?

Both are correct, but IMO Ossetian is more modern.
Comment 25 Egmont Koblinger 2018-05-24 11:35:05 IST
(In reply to Soslan Khubulov from comment #24)

> If other locales in glibc use 3 letter abbreviations [...]

That's not the case, see e.g. bug 192 and bug 22848. IMO use whichever is grammatically correct / better / more typically used etc. in the given language.
Comment 26 keld@keldix.com 2018-05-24 12:10:27 IST
On Thu, May 24, 2018 at 11:35:05AM +0000, egmont at gmail dot com wrote:
> https://sourceware.org/bugzilla/show_bug.cgi?id=23140
> 
> --- Comment #25 from Egmont Koblinger <egmont at gmail dot com> ---
> (In reply to Soslan Khubulov from comment #24)
> 
> > If other locales in glibc use 3 letter abbreviations [...]
> 
> That's not the case, see e.g. bug 192 and bug 22848. IMO use whichever is
> grammatically correct / better / more typically used etc. in the given
> language.

IMHO as we are speaking about POSIX locales, so we should use POSIX style names, that
is, oriented towards POSIX utilities use. CLDR is not oriented towards POSIX use.

Actually we should also allow for more grammatically oriented names.
But that should be new functionality, using new keywords. In that way we will
have POSIX functionality which is still functional

And I am still uncertain that what glibc is doing now is following the POSIX standard.
POSIX has recently (within the last couple of years) adressed the genitive month names problem,
in a way compatible with BSD. I have not yet gotten around to verifying that glibc is
following POSIX here.

best regards
keld
Comment 27 Rafal Luzynski 2018-05-26 12:23:09 IST
(In reply to Soslan Khubulov from comment #24)
> (In reply to Rafal Luzynski from comment #23)
> > Thank you for your review. alt_mon is currently capitalized in this patch.
> > Did you mean anything different?
> 
> I meant mon. Sorry for that.

Locale data should follow the grammar rules of respective languages.  Are there rules in Ossetian which say that the month name should always be capitalized, like in English, German and few more languages?  This page: https://os.wikipedia.org/wiki/26_%D0%BC%D0%B0%D0%B9%D1%8B says "26 майы" which is lowercase.  If this is correct then mon should be lowercase, same as CLDR provides.  Uppercasing alt_mon is not obligatory but both glibc and CLDR provide so and I will not change it without need.

> > BTW, what do you think about abbreviated month names? Currently in glibc we
> > have all Ossetian month names abbreviated to 3 letters. CLDR [1] provides
> > 3-4 letters plus a dot unless whole word is 3 or 4 letters long. As a
> > consequence some "abbreviated" month names have their inflection visible:
> > "Май" -> "майы", "Июнь" -> "июны" and so on. Also, the abbreviated
> > standalone (nominative?) forms are all capitalized.
> 
> I think consistency is more important. If other locales in glibc use 3
> letter abbreviations then Ossetian locale should use 3 letters too. As for
> usability, both styles are equally recognizable.

There is no requirement that they should be 3 letters.  Some languages follow that rule, some do not.  But if this is recognizable then I will not change it unless you request.

> > While at this, what is the correct English name: Ossetian (Wikipedia says
> > so) or Ossetic (CLDR says so)?
> 
> Both are correct, but IMO Ossetian is more modern.

I will not change it for now, either.

(In reply to Egmont Koblinger from comment #25)
> [...]
> That's not the case, see e.g. bug 192 and bug 22848. IMO use whichever is
> grammatically correct / better / more typically used etc. in the given
> language.

I fully agree, the locale data should follow the grammar rules.

(In reply to keld@keldix.com from comment #26)
> [...]
> IMHO as we are speaking about POSIX locales, so we should use POSIX style
> names, that
> is, oriented towards POSIX utilities use. CLDR is not oriented towards POSIX
> use.

I don't remember where I read this but someone wrote that those POSIX rules apply to English language, not to other languages.  POSIX authors are not aware of every language in the world, therefore the rules are occasionally amended to support more languages.

> [...]
> And I am still uncertain that what glibc is doing now is following the POSIX
> standard.
> POSIX has recently (within the last couple of years) adressed the genitive
> month names problem,
> in a way compatible with BSD. I have not yet gotten around to verifying that
> glibc is
> following POSIX here.

If you mean the bug 10871 then in a part which refers to the full month names it strictly follows the rules of BSD, also follows the update which has been accepted by POSIX in 2010 but not yet published.  Therefore until it is published we call it "GNU extension" rather than "POSIX compatible".

Regarding the part which refers to the abbreviated month names the rules are similar but nobody except glibc so far implemented or proposed it.  POSIX has been asked to accept this as part of their standard but it may take another 10 years.  For now we call it a genuine GNU extension. :-)
Comment 28 keld@keldix.com 2018-05-26 13:10:54 IST
On Sat, May 26, 2018 at 12:23:09PM +0000, digitalfreak at lingonborough dot com wrote:
> https://sourceware.org/bugzilla/show_bug.cgi?id=23140
> (In reply to keld@keldix.com from comment #26)
> > [...]
> > IMHO as we are speaking about POSIX locales, so we should use POSIX style
> > names, that
> > is, oriented towards POSIX utilities use. CLDR is not oriented towards POSIX
> > use.
> 
> I don't remember where I read this but someone wrote that those POSIX rules
> apply to English language, not to other languages.  POSIX authors are not aware
> of every language in the world, therefore the rules are occasionally amended to
> support more languages.

Well,I have been around with POSIX locales for a long time, more than 25 years, and the
locales were always meant to be it support anything else than English.
So many other languages have these rules. POSIX authors at that time, including myself,
were quite aware of the requirements for many languages - but not for all.
This is still the case, POSIX i18n authors don't know everything in the world, but we are getting better.



> > [...]
> > And I am still uncertain that what glibc is doing now is following the POSIX
> > standard.
> > POSIX has recently (within the last couple of years) adressed the genitive
> > month names problem,
> > in a way compatible with BSD. I have not yet gotten around to verifying that
> > glibc is
> > following POSIX here.
> 
> If you mean the bug 10871 then in a part which refers to the full month names
> it strictly follows the rules of BSD, also follows the update which has been
> accepted by POSIX in 2010 but not yet published.  Therefore until it is
> published we call it "GNU extension" rather than "POSIX compatible".
> 
> Regarding the part which refers to the abbreviated month names the rules are
> similar but nobody except glibc so far implemented or proposed it.  POSIX has
> been asked to accept this as part of their standard but it may take another 10
> years.  For now we call it a genuine GNU extension. :-)

I agree that POSIX may be slow sometimes. As said, it is my plan to check up on this.

Best regards
keld
Comment 29 Rafal Luzynski 2018-05-26 13:49:45 IST
(In reply to keld@keldix.com from comment #28)
> [...]
> Well,I have been around with POSIX locales for a long time, more than 25
> years, and the
> locales were always meant to be it support anything else than English.
> So many other languages have these rules. POSIX authors at that time,
> including myself,
> were quite aware of the requirements for many languages - but not for all.
> This is still the case, POSIX i18n authors don't know everything in the
> world, but we are getting better.

I appreciate your work.  I did not mean you are totally unaware but not aware of every language because this is impossible.  In this context we are discussing Ossetian language.

> 
> > [...]  POSIX has
> > been asked to accept this as part of their standard but it may take another 10
> > years.  For now we call it a genuine GNU extension. :-)
> 
> I agree that POSIX may be slow sometimes. As said, it is my plan to check up
> on this.
> 
> Best regards
> keld

Thank you. Links:

http://austingroupbugs.net/view.php?id=258
http://austingroupbugs.net/view.php?id=1166
Comment 30 Rafal Luzynski 2018-06-06 23:56:15 IST
Created attachment 11059 [details]
Kashubian (csb_PL) version 2

Updates and typo fixes:

"łżëkwiôta" -> "łżëkwiata"
"môja" -> "maja"
"lëpinca" -> "lëpińca"
Comment 31 Rafal Luzynski 2018-06-06 23:58:20 IST
Created attachment 11060 [details]
Walloon (wa_BE) version 2

1. Non-breaking spaces used to ensure that "d’" does not appear at the end of a line.
2. Reworded country_name: "Beljike" -> "Beldjike".
Comment 32 cvs-commit@gcc.gnu.org 2018-06-11 23:37:37 IST
This is an automated email from the git hooks/post-receive script. It was
generated because a ref change was pushed to the repository containing
the project "GNU C Library master sources".

The branch, master has been updated
       via  c4ad5782c44f4fa23d3ca9bec1e288c24cf2e6df (commit)
      from  ca121b117f2c9c97a4c121334481a96c94fef3a0 (commit)

Those revisions listed above that are new to this repository have
not appeared on any other notification email; so we list those
revisions in full, below.

- Log -----------------------------------------------------------------
https://sourceware.org/git/gitweb.cgi?p=glibc.git;h=c4ad5782c44f4fa23d3ca9bec1e288c24cf2e6df

commit c4ad5782c44f4fa23d3ca9bec1e288c24cf2e6df
Author: Rafal Luzynski <digitalfreak@lingonborough.com>
Date:   Tue Jan 30 12:31:12 2018 +0100

    gd_GB, hsb_DE, wa_BE: Add alternative month names (bug 23140).
    
    As a followup of fixing bug 10871, these three languages now support two
    grammatical cases of the month names.
    
    This commit does not resolve the bug because there are more languages
    to be committed.
    
    	[BZ #23140]
    	* localedata/locales/gd_GB (mon): Rename to...
    	(alt_mon): This.
    	(mon): Import from CLDR (genitive case).
    	* localedata/locales/hsb_DE (mon): Rename to...
    	(alt_mon): This.
    	(mon): Import from CLDR (genitive case).
    	* localedata/locales/wa_BE (mon): Rename to...
    	(alt_mon): This.
    	(mon): Add, fill with the proper genitive forms, but CLDR data
    	is incomplete; completed according to the comments in this file.
    	(d_t_fmt): Do not use "di" before the month name, no longer needed.
    
    	* localedata/locales/wa_BE (country_name): Reword
    	"Beljike" -> "Beldjike".

-----------------------------------------------------------------------

Summary of changes:
 ChangeLog                 |   18 ++++++++++++++++++
 NEWS                      |    7 ++++---
 localedata/locales/gd_GB  |   17 ++++++++++++++++-
 localedata/locales/hsb_DE |   14 +++++++++++++-
 localedata/locales/wa_BE  |   24 ++++++++++++++++--------
 5 files changed, 67 insertions(+), 13 deletions(-)
Comment 33 Rafal Luzynski 2018-06-12 20:53:20 IST
Created attachment 11067 [details]
Armenian (hy_AM)

I've found this in my computer and I think it is worth attention.  However, I can't read Armenian script.  Thoughts?

Here is a decoded version:

diff --git a/localedata/locales/hy_AM b/localedata/locales/hy_AM
index 805c327..74e1b77 100644
--- a/localedata/locales/hy_AM
+++ b/localedata/locales/hy_AM
@@ -130,18 +130,30 @@ abmon       "Հնվ";/
             "Հոկ";/
             "Նմբ";/
             "Դեկ"
-mon         "Հունվարի";/
-            "Փետրվարի";/
-            "Մարտի";/
-            "Ապրիլի";/
-            "Մայիսի";/
-            "Հունիսի";/
-            "Հուլիսի";/
-            "Օգոստոսի";/
-            "Սեպտեմբերի";/
-            "Հոկտեմբերի";/
-            "Նոյեմբերի";/
-            "Դեկտեմբերի"
+alt_mon     "հունվար";/
+            "փետրվար";/
+            "մարտ";/
+            "ապրիլ";/
+            "մայիս";/
+            "հունիս";/
+            "հուլիս";/
+            "օգոստոս";/
+            "սեպտեմբեր";/
+            "հոկտեմբեր";/
+            "նոյեմբեր";/
+            "դեկտեմբեր"
+mon         "հունվարի";/
+            "փետրվարի";/
+            "մարտի";/
+            "ապրիլի";/
+            "մայիսի";/
+            "հունիսի";/
+            "հուլիսի";/
+            "օգոստոսի";/
+            "սեպտեմբերի";/
+            "հոկտեմբերի";/
+            "նոյեմբերի";/
+            "դեկտեմբերի"
 d_t_fmt     "%a %d %b %Y %r %Z"
 d_fmt       "%m//%d//%y"
 t_fmt       "%r"
--
Comment 34 Rafal Luzynski 2018-06-18 10:04:25 IST
I can't even read Armenian script but I'm trying to figure out what's going on here.  Armenian alphabet seems to have upper and lowercase, same as Latin, Cyrillic, and Greek.  Glibc currently seems to provide the month names starting with uppercase.  It is easy to convert between uppercase and lowercase: uppercase code points are 0x30 less than lowercase.  For example, current March:

"<U0544><U0561><U0580><U057F><U056B>"

Decoded:

"Մարտի"

Should be transliterated as:

"Marti"

My patch which is an import from CLDR converts it to:

alt_mon: "<U0574><U0561><U0580><U057F>"        => "մարտ"  => "mart"
mon:     "<U0574><U0561><U0580><U057F><U056B>" => "մարտի" => "marti"

So it looks like the locale data currently contain the month names in a genitive case (or whatever is correct to use in a full date) starting with uppercase while CLDR uses lowercase exclusively.  Please note that we had a similar case in Lithuanian language already.

But Armenian language seems to use "month day" order, same as English, so the month name may tend to appear at the beginning of a sentence and it may be reasonable to start it with an uppercase even if there is no rule in a language which says that the month names should be always titlecased.  If mon array is titlecased then alt_mon should be as well (CLDR suggest that alt_mon may be titlecased and mon lowercased but not the reverse) so maybe we should use a titlecase for alt_mon as well.

Converting this to a titlecase the decoded patch for hy_AM would look like this:

diff --git a/localedata/locales/hy_AM b/localedata/locales/hy_AM
index 805c327..30033a9 100644
--- a/localedata/locales/hy_AM
+++ b/localedata/locales/hy_AM
@@ -130,6 +130,18 @@ abmon       "Հնվ";/
             "Հոկ";/
             "Նմբ";/
             "Դեկ"
+alt_mon     "Հունվար";/
+            "Փետրվար";/
+            "Մարտ";/
+            "Ապրիլ";/
+            "Մայիս";/
+            "Հունիս";/
+            "Հուլիս";/
+            "Օգոստոս";/
+            "Սեպտեմբեր";/
+            "Հոկտեմբեր";/
+            "Նոյեմբեր";/
+            "Դեկտեմբեր"
 mon         "Հունվարի";/
             "Փետրվարի";/
             "Մարտի";/

I'm still looking for the people to confirm this.

Links:

http://st.unicode.org/cldr-apps/v#/hy/Gregorian/
https://www.fileformat.info/info/unicode/block/armenian/list.htm
https://en.wikipedia.org/wiki/Armenian_alphabet
https://hy.wikipedia.org/wiki/%D5%84%D5%A1%D6%80%D5%BF%D5%AB_1 (this is an example of an Armenian date)
Comment 35 keld@keldix.com 2018-06-18 11:59:42 IST
If month (and day) names are not capitalized, then the should not be capitalized in our
locales, even if they often appear first in a sentence. This is damaging the culture in question.
I see a lot of instances in my own language, where people wrongly spell month (and day) names
with a capitalized first letter, and that is really not correct. Using the argumentation
below is not helping the language.

Best regards
Keld

On Mon, Jun 18, 2018 at 10:04:25AM +0000, digitalfreak at lingonborough dot com wrote:
> https://sourceware.org/bugzilla/show_bug.cgi?id=23140
> 
> --- Comment #34 from Rafal Luzynski <digitalfreak at lingonborough dot com> ---
> I can't even read Armenian script but I'm trying to figure out what's going on
> here.  Armenian alphabet seems to have upper and lowercase, same as Latin,
> Cyrillic, and Greek.  Glibc currently seems to provide the month names starting
> with uppercase.  It is easy to convert between uppercase and lowercase:
> uppercase code points are 0x30 less than lowercase.  For example, current
> March:
> 
> "<U0544><U0561><U0580><U057F><U056B>"
> 
> Decoded:
> 
> "??????????"
> 
> Should be transliterated as:
> 
> "Marti"
> 
> My patch which is an import from CLDR converts it to:
> 
> alt_mon: "<U0574><U0561><U0580><U057F>"        => "????????"  => "mart"
> mon:     "<U0574><U0561><U0580><U057F><U056B>" => "??????????" => "marti"
> 
> So it looks like the locale data currently contain the month names in a
> genitive case (or whatever is correct to use in a full date) starting with
> uppercase while CLDR uses lowercase exclusively.  Please note that we had a
> similar case in Lithuanian language already.
> 
> But Armenian language seems to use "month day" order, same as English, so the
> month name may tend to appear at the beginning of a sentence and it may be
> reasonable to start it with an uppercase even if there is no rule in a language
> which says that the month names should be always titlecased.  If mon array is
> titlecased then alt_mon should be as well (CLDR suggest that alt_mon may be
> titlecased and mon lowercased but not the reverse) so maybe we should use a
> titlecase for alt_mon as well.
> 
> Converting this to a titlecase the decoded patch for hy_AM would look like
> this:
> 
> diff --git a/localedata/locales/hy_AM b/localedata/locales/hy_AM
> index 805c327..30033a9 100644
> --- a/localedata/locales/hy_AM
> +++ b/localedata/locales/hy_AM
> @@ -130,6 +130,18 @@ abmon       "??????";/
>              "??????";/
>              "??????";/
>              "??????"
> +alt_mon     "??????????????";/
> +            "??????????????";/
> +            "????????";/
> +            "??????????";/
> +            "??????????";/
> +            "????????????";/
> +            "????????????";/
> +            "??????????????";/
> +            "??????????????????";/
> +            "??????????????????";/
> +            "????????????????";/
> +            "??????????????????"
>  mon         "????????????????";/
>              "????????????????";/
>              "??????????";/
> 
> I'm still looking for the people to confirm this.
> 
> Links:
> 
> http://st.unicode.org/cldr-apps/v#/hy/Gregorian/
> https://www.fileformat.info/info/unicode/block/armenian/list.htm
> https://en.wikipedia.org/wiki/Armenian_alphabet
> https://hy.wikipedia.org/wiki/%D5%84%D5%A1%D6%80%D5%BF%D5%AB_1 (this is an
> example of an Armenian date)
> 
> -- 
> You are receiving this mail because:
> You are on the CC list for the bug.
Comment 36 Rafal Luzynski 2018-06-18 22:56:59 IST
(In reply to keld@keldix.com from comment #35)
> If month (and day) names are not capitalized, then the should not be
> capitalized in our
> locales, even if they often appear first in a sentence.

I think we are repeating the discussion from comment 2 and comment 3.  In short terms: it would be nice to have flags allowing to select uppercase/lowercase/titlecase but such feature does not exist yet.

> This is damaging the
> culture in question.
> I see a lot of instances in my own language, where people wrongly spell
> month (and day) names
> with a capitalized first letter, and that is really not correct. Using the
> argumentation
> below is not helping the language.

I think I understand you.  But we can't fix the people wrongly spelling the month names (capitalizing where it is not correct), we can only fix software here (e.g., not capitalizing where it should).

Regarding the particular case of Armenian language I would like to leave the decision to the actual language community but I'm afraid that the community will not speak up here.  As we are not sure what to do and none of us has a sufficient knowledge I suggest not touching this language at all.
Comment 37 Rafal Luzynski 2018-06-21 10:53:04 IST
Created attachment 11093 [details]
Kashubian (csb_PL) version 3

It seems that Kashubian language also needs the ab_alt_mon feature.
Comment 38 cvs-commit@gcc.gnu.org 2018-06-25 10:45:02 IST
This is an automated email from the git hooks/post-receive script. It was
generated because a ref change was pushed to the repository containing
the project "GNU C Library master sources".

The branch, master has been updated
       via  189699ab375111a25dac19f1b4f89e38d31c8b3d (commit)
       via  0ea3f13cceaecdb3fb2219611876fdd49485e64d (commit)
      from  d93f4ff16b75f77b99cb095c3e83c9b8281261f2 (commit)

Those revisions listed above that are new to this repository have
not appeared on any other notification email; so we list those
revisions in full, below.

- Log -----------------------------------------------------------------
https://sourceware.org/git/gitweb.cgi?p=glibc.git;h=189699ab375111a25dac19f1b4f89e38d31c8b3d

commit 189699ab375111a25dac19f1b4f89e38d31c8b3d
Author: Rafal Luzynski <digitalfreak@lingonborough.com>
Date:   Tue Jan 30 12:31:12 2018 +0100

    csb_PL: Add alternative month names (bug 23140).
    
    Kashubian language is not supported by CLDR, data copied from Wikipedia
    and documents released by RJK (official Kashubian Language Council),
    also consulted with a native speaker.
    
    Note that this language also needs ab_alt_mon feature due to the month
    May: nominative "môj", genitive "maja"; abbreviated nominative "môj",
    abbreviated genitive "maj".
    
    	[BZ #23140]
    	* localedata/locales/csb_PL (mon): Rename to...
    	(alt_mon): This.
    	(abmon): Rename to...
    	(ab_alt_mon): This.
    	(mon): Add with proper genitive forms, copy from Wikipedia.
    	(abmon): Likewise.

https://sourceware.org/git/gitweb.cgi?p=glibc.git;h=0ea3f13cceaecdb3fb2219611876fdd49485e64d

commit 0ea3f13cceaecdb3fb2219611876fdd49485e64d
Author: Rafal Luzynski <digitalfreak@lingonborough.com>
Date:   Thu Jun 21 12:29:13 2018 +0200

    csb_PL: Update month translations + add yesstr/nostr (bug 19485).
    
    Thank you Michal Ostrowski for the feedback.
    
    	[BZ #19485]
    	* localedata/locales/csb_PL (mon): Fix typos:
    	"łżëkwiôt" -> "łżëkwiat" (April); "lëpinc" -> "lëpińc" (July).
    	(yesstr): Add, value is "jo".
    	(nostr): Add, value is "nié".

-----------------------------------------------------------------------

Summary of changes:
 ChangeLog                 |   18 ++++++++++++++++++
 NEWS                      |    6 +++---
 localedata/locales/csb_PL |   28 ++++++++++++++++++++++++----
 3 files changed, 45 insertions(+), 7 deletions(-)
Comment 39 Rafal Luzynski 2018-06-25 22:43:23 IST
(In reply to keld@keldix.com from comment #35)
> If month (and day) names are not capitalized, then the should not be
> capitalized in our
> locales, even if they often appear first in a sentence. [...]

OK, good news: I have managed to contact an Armenian native speaker and he agrees that the month names should be lowercased.  This convinces me and I will proceed with the patch.
Comment 40 keld@keldix.com 2018-06-26 05:28:37 IST
On Mon, Jun 25, 2018 at 10:43:23PM +0000, digitalfreak at lingonborough dot com wrote:
> https://sourceware.org/bugzilla/show_bug.cgi?id=23140
> 
> --- Comment #39 from Rafal Luzynski <digitalfreak at lingonborough dot com> ---
> (In reply to keld@keldix.com from comment #35)
> > If month (and day) names are not capitalized, then the should not be
> > capitalized in our
> > locales, even if they often appear first in a sentence. [...]
> 
> OK, good news: I have managed to contact an Armenian native speaker and he
> agrees that the month names should be lowercased.  This convinces me and I will
> proceed with the patch.

Good. You are of cause rigth in saying that we do not have a way to capitalize such
names. But then let us make a way to do it. My thoughts are to make some 
format specifier to change the first character til uppercase, both for
month and day names, and their abbreviations. I don't have a specific
proposal - but maybe a + somewhere could  do it. What do you think?

Best regards
keld
Comment 41 cvs-commit@gcc.gnu.org 2018-06-29 10:38:39 IST
This is an automated email from the git hooks/post-receive script. It was
generated because a ref change was pushed to the repository containing
the project "GNU C Library master sources".

The branch, master has been updated
       via  339124ab429ce917dfbcd75e2acc4299d27340f9 (commit)
      from  c1f86a33ca32e26a9d6e29fc961e5ecb5e2e5eb4 (commit)

Those revisions listed above that are new to this repository have
not appeared on any other notification email; so we list those
revisions in full, below.

- Log -----------------------------------------------------------------
https://sourceware.org/git/gitweb.cgi?p=glibc.git;h=339124ab429ce917dfbcd75e2acc4299d27340f9

commit 339124ab429ce917dfbcd75e2acc4299d27340f9
Author: Rafal Luzynski <digitalfreak@lingonborough.com>
Date:   Tue Jan 30 12:31:12 2018 +0100

    ast_ES: Add alternative month names (bug 23140).
    
    	[BZ #23140]
    	* localedata/locales/ast_ES (mon): Rename to...
    	(alt_mon): This.
    	(mon): Import from CLDR (genitive case).

-----------------------------------------------------------------------

Summary of changes:
 ChangeLog                 |    7 +++++++
 NEWS                      |    6 +++---
 localedata/locales/ast_ES |   17 ++++++++++++++++-
 3 files changed, 26 insertions(+), 4 deletions(-)
Comment 42 cvs-commit@gcc.gnu.org 2018-06-29 20:22:11 IST
This is an automated email from the git hooks/post-receive script. It was
generated because a ref change was pushed to the repository containing
the project "GNU C Library master sources".

The branch, master has been updated
       via  2e0c5de622749a5e1f2b01afa19ec58199cc0bdf (commit)
      from  cdb52c71821d8d7d814daf7d01fbd003daef9c22 (commit)

Those revisions listed above that are new to this repository have
not appeared on any other notification email; so we list those
revisions in full, below.

- Log -----------------------------------------------------------------
https://sourceware.org/git/gitweb.cgi?p=glibc.git;h=2e0c5de622749a5e1f2b01afa19ec58199cc0bdf

commit 2e0c5de622749a5e1f2b01afa19ec58199cc0bdf
Author: Rafal Luzynski <digitalfreak@lingonborough.com>
Date:   Fri Feb 24 03:13:15 2017 +0100

    hy_AM: Add alternative month names (bug 23140).
    
    This locale already contained correct data in mon array.  Updated from
    CLDR to start the month names with the lowercase letters.
    
    alt_mon is a new import from CLDR.  The change has been consulted
    off-list with a native speaker.
    
    	[BZ #23140]
    	* localedata/locales/hy_AM (mon): Synchronize with CLDR (lowercase,
    	genitive case).
    	(alt_mon): New entry, import from CLDR (nominative case).

-----------------------------------------------------------------------

Summary of changes:
 ChangeLog                |    7 +++++++
 NEWS                     |    2 +-
 localedata/locales/hy_AM |   36 ++++++++++++++++++++++++------------
 3 files changed, 32 insertions(+), 13 deletions(-)
Comment 43 cvs-commit@gcc.gnu.org 2018-07-17 22:01:34 IST
This is an automated email from the git hooks/post-receive script. It was
generated because a ref change was pushed to the repository containing
the project "GNU C Library master sources".

The branch, master has been updated
       via  9145f0333d11683cb3d796246d1395c84b4a3516 (commit)
      from  ba2ea23d053e293baeb39554b2e9fc56f8ef335b (commit)

Those revisions listed above that are new to this repository have
not appeared on any other notification email; so we list those
revisions in full, below.

- Log -----------------------------------------------------------------
https://sourceware.org/git/gitweb.cgi?p=glibc.git;h=9145f0333d11683cb3d796246d1395c84b4a3516

commit 9145f0333d11683cb3d796246d1395c84b4a3516
Author: Rafal Luzynski <digitalfreak@lingonborough.com>
Date:   Tue Jan 30 12:31:12 2018 +0100

    os_RU: Add alternative month names (bug 23140).
    
    	[BZ #23140]
    	* localedata/locales/os_RU (mon): Rename to...
    	(alt_mon): This.
    	(mon): Import from CLDR (genitive case).
    
    Reviewed-by: Carlos O'Donell <carlos@redhat.com>

-----------------------------------------------------------------------

Summary of changes:
 ChangeLog                |    7 +++++++
 NEWS                     |    6 +++---
 localedata/locales/os_RU |   15 ++++++++++++++-
 3 files changed, 24 insertions(+), 4 deletions(-)
Comment 44 cvs-commit@gcc.gnu.org 2018-07-18 21:21:17 IST
This is an automated email from the git hooks/post-receive script. It was
generated because a ref change was pushed to the repository containing
the project "GNU C Library master sources".

The branch, master has been updated
       via  df467d229ac53098d06ffd7b86322a1e22bf6013 (commit)
      from  5c112f1b62b6fca7348c64a004e9fc4cfdaca1ad (commit)

Those revisions listed above that are new to this repository have
not appeared on any other notification email; so we list those
revisions in full, below.

- Log -----------------------------------------------------------------
https://sourceware.org/git/gitweb.cgi?p=glibc.git;h=df467d229ac53098d06ffd7b86322a1e22bf6013

commit df467d229ac53098d06ffd7b86322a1e22bf6013
Author: Quentin PAGÈS <provaires@quentino.fr>
Date:   Sat May 19 17:59:08 2018 +0200

    oc_FR locale: Multiple updates (bug 23140, bug 23422).
    
    Multiple updates for Occitan language including alternative month names,
    update abday and abmon, fix typos in day, fix d_fmt, correct LC_NAME,
    and use “copy "ca_ES"” as LC_COLLATE.
    
    	[BZ #23140]
    	* localedata/locales/oc_FR (mon): Rename to...
    	(alt_mon): This, then update October (typo fix).
    	(mon): New content (genitive case, month names preceded by
    	"de" or "d’").
    
    	[BZ #23422]
    	* localedata/locales/oc_FR (abday): Update all items.
    	(day): Update Wednesday and Saturday (typo fixes).
    	(abmon): Update all items, except May.
    	(d_fmt): Update "%d.%m.%Y" -> "%d/%m/%Y".
    	(LC_IDENTIFICATION): Bump the revision number and date.
    	Keep the "category" entries in alphabetic order.
    	(LC_ADDRESS): Remove no longer needed comment.
    	(LC_COLLATE): Use “copy "ca_ES"”.
    	(LC_NAME): Set the correct values of "name_fmt", "name_mr", and
    	"name_mrs".
    
    Reviewed-by: Carlos O'Donell <carlos@redhat.com>

-----------------------------------------------------------------------

Summary of changes:
 ChangeLog                |   20 ++++++++++++++
 NEWS                     |    2 +-
 localedata/locales/oc_FR |   64 ++++++++++++++++++++++++++++-----------------
 3 files changed, 61 insertions(+), 25 deletions(-)
Comment 45 Rafal Luzynski 2018-07-18 21:27:51 IST
Fixed all I was able to fix.  Here is what remains not fixed:

* Finnish: I think it would be good but the existing workaround seems to be sufficient for the actual native speakers.
* Slovak: I would like to consult the actual native community because their rules of nominative/genitive cases seem to be different than in other languages.
* Serbian: the same as in Slovak + I don't have a reliable list of translated month names.
* Silesian: definitely needs an update but I don't have a reliable list of month names.
Comment 46 Rafal Luzynski 2018-07-18 22:44:31 IST
(In reply to keld@keldix.com from comment #40)
> Good. You are of cause rigth in saying that we do not have a way to
> capitalize such
> names. But then let us make a way to do it. My thoughts are to make some 
> format specifier to change the first character til uppercase, both for
> month and day names, and their abbreviations. I don't have a specific
> proposal - but maybe a + somewhere could  do it. What do you think?

This may be a good idea.  Let's continue this discussion in bug 21370 which I've created in order to handle this.
Comment 47 cvs-commit@gcc.gnu.org 2018-08-01 05:51:49 IST
This is an automated email from the git hooks/post-receive script. It was
generated because a ref change was pushed to the repository containing
the project "GNU C Library master sources".

The annotated tag, glibc-2.28 has been created
        at  0774a9618b539692317d0950477e16a8c5074caf (tag)
   tagging  3c03baca37fdcb52c3881e653ca392bba7a99c2b (commit)
  replaces  glibc-2.27.9000
 tagged by  Carlos O'Donell
        on  Wed Aug 1 01:20:23 2018 -0400

- Log -----------------------------------------------------------------
The GNU C Library
=================

The GNU C Library version 2.28 is now available.

The GNU C Library is used as *the* C library in the GNU system and
in GNU/Linux systems, as well as many other systems that use Linux
as the kernel.

The GNU C Library is primarily designed to be a portable
and high performance C library.  It follows all relevant
standards including ISO C11 and POSIX.1-2008.  It is also
internationalized and has one of the most complete
internationalization interfaces known.

The GNU C Library webpage is at http://www.gnu.org/software/libc/

Packages for the 2.28 release may be downloaded from:
        http://ftpmirror.gnu.org/libc/
        http://ftp.gnu.org/gnu/libc/

The mirror list is at http://www.gnu.org/order/ftp.html

NEWS for version 2.28
=====================

Major new features:

* The localization data for ISO 14651 is updated to match the 2016
  Edition 4 release of the standard, this matches data provided by
  Unicode 9.0.0.  This update introduces significant improvements to the
  collation of Unicode characters.  This release deviates slightly from
  the standard in that the collation element ordering for lowercase and
  uppercase LATIN script characters is adjusted to ensure that regular
  expressions with ranges like [a-z] and [A-Z] don't interleave e.g. A
  is not matched by [a-z].  With the update many locales have been
  updated to take advantage of the new collation information.  The new
  collation information has increased the size of the compiled locale
  archive or binary locales.

* The GNU C Library can now be compiled with support for Intel CET, AKA
  Intel Control-flow Enforcement Technology.  When the library is built
  with --enable-cet, the resulting glibc is protected with indirect
  branch tracking (IBT) and shadow stack (SHSTK).  CET-enabled glibc is
  compatible with all existing executables and shared libraries.  This
  feature is currently supported on i386, x86_64 and x32 with GCC 8 and
  binutils 2.29 or later.  Note that CET-enabled glibc requires CPUs
  capable of multi-byte NOPs, like x86-64 processors as well as Intel
  Pentium Pro or newer.  NOTE: --enable-cet has been tested for i686,
  x86_64 and x32 on non-CET processors.  --enable-cet has been tested
  for x86_64 and x32 on CET SDVs, but Intel CET support hasn't been
  validated for i686.

* The GNU C Library now has correct support for ABSOLUTE symbols
  (SHN_ABS-relative symbols).  Previously such ABSOLUTE symbols were
  relocated incorrectly or in some cases discarded.  The GNU linker can
  make use of the newer semantics, but it must communicate it to the
  dynamic loader by setting the ELF file's identification (EI_ABIVERSION
  field) to indicate such support is required.

* Unicode 11.0.0 Support: Character encoding, character type info, and
  transliteration tables are all updated to Unicode 11.0.0, using
  generator scripts contributed by Mike FABIAN (Red Hat).

* <math.h> functions that round their results to a narrower type are added
  from TS 18661-1:2014 and TS 18661-3:2015:

  - fadd, faddl, daddl and corresponding fMaddfN, fMaddfNx, fMxaddfN and
    fMxaddfNx functions.

  - fsub, fsubl, dsubl and corresponding fMsubfN, fMsubfNx, fMxsubfN and
    fMxsubfNx functions.

  - fmul, fmull, dmull and corresponding fMmulfN, fMmulfNx, fMxmulfN and
    fMxmulfNx functions.

  - fdiv, fdivl, ddivl and corresponding fMdivfN, fMdivfNx, fMxdivfN and
    fMxdivfNx functions.

* Two grammatical forms of month names are now supported for the following
  languages: Armenian, Asturian, Catalan, Czech, Kashubian, Occitan, Ossetian,
  Scottish Gaelic, Upper Sorbian, and Walloon.  The following languages now
  support two grammatical forms in abbreviated month names: Catalan, Greek,
  and Kashubian.

* Newly added locales: Lower Sorbian (dsb_DE) and Yakut (sah_RU) also
  include the support for two grammatical forms of month names.

* Building and running on GNU/Hurd systems now works without out-of-tree
  patches.

* The renameat2 function has been added, a variant of the renameat function
  which has a flags argument.  If the flags are zero, the renameat2 function
  acts like renameat.  If the flag is not zero and there is no kernel
  support for renameat2, the function will fail with an errno value of
  EINVAL.  This is different from the existing gnulib function renameatu,
  which performs a plain rename operation in case of a RENAME_NOREPLACE
  flags and a non-existing destination (and therefore has a race condition
  that can clobber the destination inadvertently).

* The statx function has been added, a variant of the fstatat64
  function with an additional flags argument.  If there is no direct
  kernel support for statx, glibc provides basic stat support based on
  the fstatat64 function.

* IDN domain names in getaddrinfo and getnameinfo now use the system libidn2
  library if installed.  libidn2 version 2.0.5 or later is recommended.  If
  libidn2 is not available, internationalized domain names are not encoded
  or decoded even if the AI_IDN or NI_IDN flags are passed to getaddrinfo or
  getnameinfo.  (getaddrinfo calls with non-ASCII names and AI_IDN will fail
  with an encoding error.)  Flags which used to change the IDN encoding and
  decoding behavior (AI_IDN_ALLOW_UNASSIGNED, AI_IDN_USE_STD3_ASCII_RULES,
  NI_IDN_ALLOW_UNASSIGNED, NI_IDN_USE_STD3_ASCII_RULES) have been
  deprecated.  They no longer have any effect.

* Parsing of dynamic string tokens in DT_RPATH, DT_RUNPATH, DT_NEEDED,
  DT_AUXILIARY, and DT_FILTER has been expanded to support the full
  range of ELF gABI expressions including such constructs as
  '$ORIGIN$ORIGIN' (if valid).  For SUID/GUID applications the rules
  have been further restricted, and where in the past a dynamic string
  token sequence may have been interpreted as a literal string it will
  now cause a load failure.  These load failures were always considered
  unspecified behaviour from the perspective of the dynamic loader, and
  for safety are now load errors e.g. /foo/${ORIGIN}.so in DT_NEEDED
  results in a load failure now.

* Support for ISO C threads (ISO/IEC 9899:2011) has been added.  The
  implementation includes all the standard functions provided by
  <threads.h>:

  - thrd_current, thrd_equal, thrd_sleep, thrd_yield, thrd_create,
    thrd_detach, thrd_exit, and thrd_join for thread management.

  - mtx_init, mtx_lock, mtx_timedlock, mtx_trylock, mtx_unlock, and
    mtx_destroy for mutual exclusion.

  - call_once for function call synchronization.

  - cnd_broadcast, cnd_destroy, cnd_init, cnd_signal, cnd_timedwait, and
    cnd_wait for conditional variables.

  - tss_create, tss_delete, tss_get, and tss_set for thread-local storage.

  Application developers must link against libpthread to use ISO C threads.

Deprecated and removed features, and other changes affecting compatibility:

* The nonstandard header files <libio.h> and <_G_config.h> are no longer
  installed.  Software that was using either header should be updated to
  use standard <stdio.h> interfaces instead.

* The stdio functions 'getc' and 'putc' are no longer defined as macros.
  This was never required by the C standard, and the macros just expanded
  to call alternative names for the same functions.  If you hoped getc and
  putc would provide performance improvements over fgetc and fputc, instead
  investigate using (f)getc_unlocked and (f)putc_unlocked, and, if
  necessary, flockfile and funlockfile.

* All stdio functions now treat end-of-file as a sticky condition.  If you
  read from a file until EOF, and then the file is enlarged by another
  process, you must call clearerr or another function with the same effect
  (e.g. fseek, rewind) before you can read the additional data.  This
  corrects a longstanding C99 conformance bug.  It is most likely to affect
  programs that use stdio to read interactive input from a terminal.
  (Bug #1190.)

* The macros 'major', 'minor', and 'makedev' are now only available from
  the header <sys/sysmacros.h>; not from <sys/types.h> or various other
  headers that happen to include <sys/types.h>.  These macros are rarely
  used, not part of POSIX nor XSI, and their names frequently collide with
  user code; see https://sourceware.org/bugzilla/show_bug.cgi?id=19239 for
  further explanation.

  <sys/sysmacros.h> is a GNU extension.  Portable programs that require
  these macros should first include <sys/types.h>, and then include
  <sys/sysmacros.h> if __GNU_LIBRARY__ is defined.

* The tilegx*-*-linux-gnu configurations are no longer supported.

* The obsolete function ustat is no longer available to newly linked
  binaries; the headers <ustat.h> and <sys/ustat.h> have been removed.  This
  function has been deprecated in favor of fstatfs and statfs.

* The obsolete function nfsservctl is no longer available to newly linked
  binaries.  This function was specific to systems using the Linux kernel
  and could not usefully be used with the GNU C Library on systems with
  version 3.1 or later of the Linux kernel.

* The obsolete function name llseek is no longer available to newly linked
  binaries.  This function was specific to systems using the Linux kernel
  and was not declared in a header.  Programs should use the lseek64 name
  for this function instead.

* The AI_IDN_ALLOW_UNASSIGNED and NI_IDN_ALLOW_UNASSIGNED flags for the
  getaddrinfo and getnameinfo functions have been deprecated.  The behavior
  previously selected by them is now always enabled.

* The AI_IDN_USE_STD3_ASCII_RULES and NI_IDN_USE_STD3_ASCII_RULES flags for
  the getaddrinfo and getnameinfo functions have been deprecated.  The STD3
  restriction (rejecting '_' in host names, among other things) has been
  removed, for increased compatibility with non-IDN name resolution.

* The fcntl function now have a Long File Support variant named fcntl64.  It
  is added to fix some Linux Open File Description (OFD) locks usage on non
  LFS mode.  As for others *64 functions, fcntl64 semantics are analogous with
  fcntl and LFS support is handled transparently.  Also for Linux, the OFD
  locks act as a cancellation entrypoint.

* The obsolete functions encrypt, encrypt_r, setkey, setkey_r, cbc_crypt,
  ecb_crypt, and des_setparity are no longer available to newly linked
  binaries, and the headers <rpc/des_crypt.h> and <rpc/rpc_des.h> are no
  longer installed.  These functions encrypted and decrypted data with the
  DES block cipher, which is no longer considered secure.  Software that
  still uses these functions should switch to a modern cryptography library,
  such as libgcrypt.

* Reflecting the removal of the encrypt and setkey functions above, the
  macro _XOPEN_CRYPT is no longer defined.  As a consequence, the crypt
  function is no longer declared unless _DEFAULT_SOURCE or _GNU_SOURCE is
  enabled.

* The obsolete function fcrypt is no longer available to newly linked
  binaries.  It was just another name for the standard function crypt,
  and it has not appeared in any header file in many years.

* We have tentative plans to hand off maintenance of the passphrase-hashing
  library, libcrypt, to a separate development project that will, we hope,
  keep up better with new passphrase-hashing algorithms.  We will continue
  to declare 'crypt' in <unistd.h>, and programs that use 'crypt' or
  'crypt_r' should not need to change at all; however, distributions will
  need to install <crypt.h> and libcrypt from a separate project.

  In this release, if the configure option --disable-crypt is used, glibc
  will not install <crypt.h> or libcrypt, making room for the separate
  project's versions of these files.  The plan is to make this the default
  behavior in a future release.

Changes to build and runtime requirements:

  GNU make 4.0 or later is now required to build glibc.

Security related changes:

  CVE-2016-6261, CVE-2016-6263, CVE-2017-14062: Various vulnerabilities have
  been fixed by removing the glibc-internal IDNA implementation and using
  the system-provided libidn2 library instead.  Originally reported by Hanno
  Böck and Christian Weisgerber.

  CVE-2017-18269: An SSE2-based memmove implementation for the i386
  architecture could corrupt memory.  Reported by Max Horn.

  CVE-2018-11236: Very long pathname arguments to realpath function could
  result in an integer overflow and buffer overflow.  Reported by Alexey
  Izbyshev.

  CVE-2018-11237: The mempcpy implementation for the Intel Xeon Phi
  architecture could write beyond the target buffer, resulting in a buffer
  overflow.  Reported by Andreas Schwab.

The following bugs are resolved with this release:

  [1190] stdio: fgetc()/fread() behaviour is not POSIX compliant
  [6889] manual: 'PWD' mentioned but not specified
  [13575] libc: SSIZE_MAX defined as LONG_MAX is inconsistent with ssize_t,
    when __WORDSIZE != 64
  [13762] regex: re_search etc. should return -2 on memory exhaustion
  [13888] build: /tmp usage during testing
  [13932] math: dbl-64 pow unexpectedly slow for some inputs
  [14092] nptl: Support C11 threads
  [14095] localedata: Review / update collation data from Unicode / ISO
    14651
  [14508] libc: -Wformat warnings
  [14553] libc: Namespace pollution loff_t in sys/types.h
  [14890] libc: Make NT_PRFPREG canonical.
  [15105] libc: Extra PLT references with -Os
  [15512] libc: __bswap_constant_16 not compiled when -Werror -Wsign-
    conversion is given
  [16335] manual: Feature test macro documentation incomplete and out of
    date
  [16552] libc: Unify umount implementations in terms of umount2
  [17082] libc: htons et al.: statement-expressions prevent use on global
    scope with -O1 and higher
  [17343] libc: Signed integer overflow in /stdlib/random_r.c
  [17438] localedata: pt_BR: wrong d_fmt delimiter
  [17662] libc: please implement binding for the new renameat2 syscall
  [17721] libc: __restrict defined as /* Ignore */ even in c11
  [17979] libc: inconsistency between uchar.h and stdint.h
  [18018] dynamic-link: Additional $ORIGIN handling issues (CVE-2011-0536)
  [18023] libc: extend_alloca is broken (questionable pointer comparison,
    horrible machine code)
  [18124] libc: hppa: setcontext erroneously returns -1 as exit code for
    last constant.
  [18471] libc: llseek should be a compat symbol
  [18473] soft-fp: [powerpc-nofpu] __sqrtsf2, __sqrtdf2 should be compat
    symbols
  [18991] nss: nss_files skips large entry in database
  [19239] libc: Including stdlib.h ends up with macros major and minor being
    defined
  [19463] libc: linknamespace failures when compiled with -Os
  [19485] localedata: csb_PL: Update month translations + add yesstr/nostr
  [19527] locale: Normalized charset name not recognized by setlocale
  [19667] string: Missing Sanity Check for malloc calls in file 'testcopy.c'
  [19668] libc: Missing Sanity Check for malloc() in file 'tst-setcontext-
    fpscr.c'
  [19728] network: out of bounds stack read in libidn function
    idna_to_ascii_4i (CVE-2016-6261)
  [19729] network: out of bounds heap read on invalid utf-8 inputs in
    stringprep_utf8_nfkc_normalize (CVE-2016-6263)
  [19818] dynamic-link: Absolute (SHN_ABS) symbols incorrectly relocated by
    the base address
  [20079] libc: Add SHT_X86_64_UNWIND to elf.h
  [20251] libc: 32bit programs pass garbage in struct flock for OFD locks
  [20419] dynamic-link: files with large allocated notes crash in
    open_verify
  [20530] libc: bswap_16 should use __builtin_bswap16() when available
  [20890] dynamic-link: ldconfig: fsync the files before atomic rename
  [20980] manual: CFLAGS environment variable replaces vital options
  [21163] regex: Assertion failure in pop_fail_stack when executing a
    malformed regexp (CVE-2015-8985)
  [21234] manual: use of CFLAGS makes glibc detect no optimization
  [21269] dynamic-link: i386 sigaction sa_restorer handling is wrong
  [21313] build: Compile Error GCC 5.4.0 MIPS with -0S
  [21314] build: Compile Error GCC 5.2.0 MIPS with -0s
  [21508] locale: intl/tst-gettext failure with latest msgfmt
  [21547] localedata: Tibetan script collation broken (Dzongkha and Tibetan)
  [21812] network: getifaddrs() returns entries with ifa_name == NULL
  [21895] libc: ppc64 setjmp/longjmp not fully interoperable with static
    dlopen
  [21942] dynamic-link: _dl_dst_substitute incorrectly handles $ORIGIN: with
    AT_SECURE=1
  [22241] localedata: New locale: Yakut (Sakha) locale for Russia (sah_RU)
  [22247] network: Integer overflow in the decode_digit function in
    puny_decode.c in libidn (CVE-2017-14062)
  [22342] nscd: NSCD not properly caching netgroup
  [22391] nptl: Signal function clear NPTL internal symbols inconsistently
  [22550] localedata: es_ES locale (and  other es_* locales):  collation
    should treat ñ  as a primary different character,  sync the collation
    for Spanish with CLDR
  [22638] dynamic-link: sparc: static binaries are broken if glibc is built
    by gcc configured with --enable-default-pie
  [22639] time: year 2039 bug for localtime etc. on 64-bit platforms
  [22644] string: memmove-sse2-unaligned on 32bit x86 produces garbage when
    crossing 2GB threshold (CVE-2017-18269)
  [22646] localedata: redundant data (LC_TIME) for es_CL, es_CU, es_EC and
    es_BO
  [22735] time: Misleading typo in time.h source comment regarding
    CLOCKS_PER_SECOND
  [22753] libc: preadv2/pwritev2 fallback code should handle offset=-1
  [22761] libc: No trailing `%n' conversion specifier in FMT passed from
    `__assert_perror_fail ()' to `__assert_fail_base ()'
  [22766] libc: all glibc internal dlopen should use RTLD_NOW for robust
    dlopen failures
  [22786] libc: Stack buffer overflow in realpath() if input size is close
    to SSIZE_MAX (CVE-2018-11236)
  [22787] dynamic-link: _dl_check_caller returns false when libc is linked
    through an absolute DT_NEEDED path
  [22792] build: tcb-offsets.h dependency dropped
  [22797] libc: pkey_get() uses non-reserved name of argument
  [22807] libc: PTRACE_* constants missing for powerpc
  [22818] glob: posix/tst-glob_lstat_compat failure on alpha
  [22827] dynamic-link: RISC-V ELF64 parser mis-reads flag in ldconfig
  [22830] malloc: malloc_stats doesn't restore cancellation state on stderr
  [22848] localedata: ca_ES: update date definitions from CLDR
  [22862] build: _DEFAULT_SOURCE is defined even when _ISOC11_SOURCE is
  [22884] math: RISCV fmax/fmin handle signalling NANs incorrectly
  [22896] localedata: Update locale data for an_ES
  [22902] math: float128 test failures with GCC 8
  [22918] libc: multiple common of `__nss_shadow_database'
  [22919] libc: sparc32: backtrace yields infinite backtrace with
    makecontext
  [22926] libc: FTBFS on powerpcspe
  [22932] localedata: lt_LT: Update of abbreviated month names from CLDR
    required
  [22937] localedata: Greek (el_GR, el_CY) locales actually need ab_alt_mon
  [22947] libc: FAIL: misc/tst-preadvwritev2
  [22963] localedata: cs_CZ: Add alternative month names
  [22987] math: [powerpc/sparc] fdim inlines errno, exceptions handling
  [22996] localedata: change LC_PAPER to en_US in es_BO locale
  [22998] dynamic-link: execstack tests are disabled when SELinux is
    disabled
  [23005] network: Crash in __res_context_send after memory allocation
    failure
  [23007] math: strtod cannot handle -nan
  [23024] nss: getlogin_r is performing NSS lookups when loginid isn't set
  [23036] regex: regex equivalence class regression
  [23037] libc: initialize msg_flags to zero for sendmmsg() calls
  [23069] libc: sigaction broken on riscv64-linux-gnu
  [23094] localedata: hr_HR: wrong thousands_sep and mon_thousands_sep
  [23102] dynamic-link: Incorrect parsing of multiple consecutive $variable
    patterns in runpath entries (e.g. $ORIGIN$ORIGIN)
  [23137] nptl: s390: pthread_join sometimes block indefinitely (on 31bit
    and libc build with -Os)
  [23140] localedata: More languages need two forms of month names
  [23145] libc: _init/_fini aren't marked as hidden
  [23152] localedata: gd_GB: Fix typo in "May" (abbreviated)
  [23171] math: C++ iseqsig for long double converts arguments to double
  [23178] nscd: sudo will fail when it is run in concurrent with commands
    that changes /etc/passwd
  [23196] string: __mempcpy_avx512_no_vzeroupper mishandles large copies
    (CVE-2018-11237)
  [23206] dynamic-link: static-pie + dlopen breaks debugger interaction
  [23208] localedata: New locale - Lower Sorbian (dsb)
  [23233] regex: Memory leak in build_charclass_op function in file
    posix/regcomp.c
  [23236] stdio: Harden function pointers in _IO_str_fields
  [23250] nptl: Offset of __private_ss differs from GCC
  [23253] math: tgamma test suite failures on i686 with -march=x86-64
    -mtune=generic -mfpmath=sse
  [23259] dynamic-link: Unsubstituted ${ORIGIN} remains in DT_NEEDED for
    AT_SECURE
  [23264] libc: posix_spawnp wrongly executes ENOEXEC in non compat mode
  [23266] nis: stringop-truncation warning with new gcc8.1 in nisplus-
    parser.c
  [23272] math: fma(INFINITY,INFIITY,0.0) should be INFINITY
  [23277] math: nan function should not have const attribute
  [23279] math: scanf and strtod wrong for some hex floating-point
  [23280] math: wscanf rounds wrong; wcstod is ok for negative numbers and
    directed rounding
  [23290] localedata: IBM273 is not equivalent to ISO-8859-1
  [23303] build: undefined reference to symbol
    '__parse_hwcap_and_convert_at_platform@@GLIBC_2.23'
  [23307] dynamic-link: Absolute symbols whose value is zero ignored in
    lookup
  [23313] stdio: libio vtables validation and standard file object
    interposition
  [23329] libc: The __libc_freeres infrastructure is not properly run across
    DSO boundaries.
  [23349] libc: Various glibc headers no longer compatible with
    <linux/time.h>
  [23351] malloc: Remove unused code related to heap dumps and malloc
    checking
  [23363] stdio: stdio-common/tst-printf.c has non-free license
  [23396] regex: Regex equivalence regression in single-byte locales
  [23422] localedata: oc_FR: More updates of locale data
  [23442] build: New warning with GCC 8
  [23448] libc: Out of bounds access in IBM-1390 converter
  [23456] libc: Wrong index_cpu_LZCNT
  [23458] build: tst-get-cpu-features-static isn't added to tests
  [23459] libc: COMMON_CPUID_INDEX_80000001 isn't populated for Intel
    processors
  [23467] dynamic-link: x86/CET: A property note parser bug

Release Notes
=============

https://sourceware.org/glibc/wiki/Release/2.28

Contributors
============

This release was made possible by the contributions of many people.
The maintainers are grateful to everyone who has contributed
changes or bug reports.  These include:

Adhemerval Zanella
Agustina Arzille
Alan Modra
Alexandre Oliva
Amit Pawar
Andreas Schwab
Andrew Senkevich
Andrew Waterman
Aurelien Jarno
Carlos O'Donell
Chung-Lin Tang
DJ Delorie
Daniel Alvarez
David Michael
Dmitry V. Levin
Dragan Stanojevic - Nevidljivi
Florian Weimer
Flávio Cruz
Francois Goichon
Gabriel F. T. Gomes
H.J. Lu
Herman ten Brugge
Hongbo Zhang
Igor Gnatenko
Jesse Hathaway
John David Anglin
Joseph Myers
Leonardo Sandoval
Maciej W. Rozycki
Mark Wielaard
Martin Sebor
Michael Wolf
Mike FABIAN
Patrick McGehearty
Patsy Franklin
Paul Pluzhnikov
Quentin PAGÈS
Rafal Luzynski
Rajalakshmi Srinivasaraghavan
Raymond Nicholson
Rical Jasan
Richard Braun
Robert Buj
Rogerio Alves
Samuel Thibault
Sean McKean
Siddhesh Poyarekar
Stefan Liebler
Steve Ellcey
Sylvain Lesage
Szabolcs Nagy
Thomas Schwinge
Tulio Magno Quites Machado Filho
Valery Timiriliyev
Vincent Chen
Wilco Dijkstra
Zack Weinberg
Zong Li
-----BEGIN PGP SIGNATURE-----

iQIcBAABAgAGBQJbYUMhAAoJEBZ5K06iU0D4LV8QAJDI+9To34wUWGmYUmV48NFx
9Mug7Yd7Y8kpo0Rxi/yPpBBAjQadz4zJftkvZJUlZsYL83jypgRhxlXaOvyBATqT
COHK3+RRaKqTcnBgSQmR34tGJh1k9CSfvfmRWxs1SycQQMhTbkQ7bLEGJEWDava6
PYCsQloDAaZdjumHNCoyTbg9fObqUlyqw3OyRJYWx07Bbl2nQc6Y/WLb4pgdWz0Y
yy7kNM6P70+uFbb/+9iPnXJ4avWbpXO68Y1WeuMFtiL7sQ/qr6sNQ1HHdqut94LB
XF7tiQ3/vWkMoJT+GkQr0rhrlTXBv+h77NFTPuewRPviYWgIWMThk3T7D2+TM8Sn
Y9hkKTpCA2qrDRK6IMMzxKAfo9+DyO66cSXM3cwCzKOtpMXdlZqRg9TlAFMjmXGr
r1KFpZzdHdw5qqktYQnIa1JBh0+31JhWXB/XxvoJx5nSDuBbJ4x55M8IeG3PCy3x
ejgCJ6bJODOChlGhE6FN4VJM+WSjd8ZY8K4T2XGdP+3zVc+zyNqLDTpdydR6t1nB
H5Peqbg12g8IJD7kY/i4Jm2uFpxP32CD3lUhp2gEbACRlZTmcxc6Bl13jgEdgKrW
AD1dxH7i9xI/Rff2hp23U5d1NAiJmWTfAgUU2939rYU+02UWUPnk/TvzMzIaTYGo
MIRvKIvblBn6bCUxYTQP
=dTj9
-----END PGP SIGNATURE-----

Adhemerval Zanella (48):
      Update SH libm-tests-ulps
      Rename nptl-signals.h to internal-signals.h
      Refactor atfork handlers
      Update sparc ulps
      i386: Fix i386 sigaction sa_restorer initialization (BZ#21269)
      nptl: Fix tst-cancel4 sendto tests
      Define _DIRENT_MATCHES_DIRENT64 regardless
      Refactor Linux ARCH_FORK implementation
      powerpc: Fix TLE build for SPE (BZ #22926)
      sparc: Fix arch_fork definition
      Add Changelog reference to BZ#23024
      Assume O_DIRECTORY for opendir
      Filter out NPTL internal signals (BZ #22391)
      linux: Consolidate sigaction implementation
      Update ARM libm-test-ulps.
      Update SPARC libm-test-ulps.
      Update i386 libm-test-ulps.
      Consolidate Linux readdir{64}{_r} implementation
      arm: Remove ununsed ARM code in optimized implementation
      Consolidate Linux getdents{64} implementation
      Fix mips64n32 getdents alias
      Consolidate scandir{at}{64} implementation
      Update hppa libm-test-ulps
      Consolidate alphasort{64} and versionsort{64} implementation
      Consolidate getdirentries{64} implementation
      Consolidate Linux readahead implementation
      Deprecate ustat syscall interface
      Fix ChangeLog from cf2478d53ad commit
      Fix concurrent changes on nscd aware files (BZ #23178)
      posix: Fix posix_spawnp to not execute invalid binaries in non compat mode (BZ#23264)
      Fix Linux fcntl OFD locks for non-LFS architectures (BZ#20251)
      Revert hurd errno.h changes
      Fix hurd expected fcntl version
      posix: Sync gnulib regex implementation
      posix: Fix bug-regex33 after regex sync
      Comment tst-ofdlocks-compat expected failure in some Linux releases
      nptl: Add C11 threads thrd_* functions
      nptl: Add C11 threads mtx_* functions
      nptl: Add C11 threads call_once functions
      nptl: Add C11 threads cnd_* functions
      nptl: Add C11 threads tss_* functions
      nptl: Add abilist symbols for C11 threads
      nptl: Add test cases for ISO C11 threads
      Mention ISO C threads addition
      Fix C11 conformance issues
      Fix ISO C threads installed header and HURD assumption
      Fix Linux fcntl OFD locks on unsupported kernels
      Update SH libm-tests-ulps

Agustina Arzille (2):
      hurd: Rewrite __libc_cleanup_*
      hurd: Reimplement libc locks using mach's gsync

Alan Modra (1):
      R_PARISC_TLS_DTPOFF32 reloc handling

Alexandre Oliva (1):
      Revert:

Amit Pawar (1):
      Use AVX_Fast_Unaligned_Load from Zen onwards.

Andreas Schwab (11):
      Fix uninitialized variable in assert_perror (bug 22761)
      Fix multiple definitions of __nss_*_database (bug 22918)
      RISC-V: add remaining relocations
      Fix crash in resolver on memory allocation failure (bug 23005)
      Fix missing @ before texinfo command
      Add aliases to recognize normalized charset names (bug 19527)
      Fix comment typo
      Remove unneeded setting of errno after malloc failure
      Don't write beyond destination in __mempcpy_avx512_no_vzeroupper (bug 23196)
      Fix out-of-bounds access in IBM-1390 converter (bug 23448)
      Fix out of bounds access in findidxwc (bug 23442)

Andrew Senkevich (1):
      Fix i386 memmove issue (bug 22644).

Andrew Waterman (1):
      RISC-V: fmax/fmin: Handle signalling NaNs correctly.

Aurelien Jarno (4):
      intl/tst-gettext: fix failure with newest msgfmt
      Fix posix/tst-glob_lstat_compat on alpha [BZ #22818]
      sparc32: Add nop before __startcontext to stop unwinding [BZ #22919]
      Add tst-sigaction.c to test BZ #23069

Carlos O'Donell (17):
      Fix -Os log1p, log1pf build (bug 21314).
      Improve DST handling (Bug 23102, Bug 21942, Bug 18018, Bug 23259).
      Fix fallback path in __pthread_mutex_timedlock ().
      Fix comments in _dl_dst_count and _dl_dst_substitute.
      libc: Extend __libc_freeres framework (Bug 23329).
      locale: XFAIL newlocale usage in static binary (Bug 23164)
      Keep expected behaviour for [a-z] and [A-z] (Bug 23393).
      Add missing localedata/en_US.UTF-8.in (Bug 23393).
      Update libc.pot.
      Update NEWS with ISO 14651 update information.
      Update translations for cs, pl, and uk.
      Update translations for bg, de, hr, pt_BR, sv, and vi.
      Update translation for be.
      Update contrib.texi contributions.
      Update tooling versions verified to work with glibc.
      Synchronize translation project PO files.
      Update NEWS, version.h, and features.h for glibc 2.28.

Chung-Lin Tang (1):
      Update sysdeps/nios2/libm-test-ulps

DJ Delorie (5):
      [RISC-V] Fix parsing flags in ELF64 files.
      RISC-V: Do not initialize $gp in TLS macros.
      Update ChangeLog for BZ 22884 - riscv fmax/fmin
      [BZ #22342] Fix netgroup cache keys.
      Update kernel version in syscall-names.list to 4.16.

Daniel Alvarez (1):
      getifaddrs: Don't return ifa entries with NULL names [BZ #21812]

David Michael (1):
      Lookup the startup server through /servers/startup

Dmitry V. Levin (3):
      linux/aarch64: sync sys/ptrace.h with Linux 4.15 [BZ #22433]
      linux/powerpc: sync sys/ptrace.h with Linux 4.15 [BZ #22433, #22807]
      Update translations from the Translation Project

Dragan Stanojevic - Nevidljivi (1):
      hr_HR locale: fix thousands_sep and mon_thousands_sep

Florian Weimer (72):
      preadv2/pwritev2: Handle offset == -1 [BZ #22753]
      Record CVE-2018-6551 in NEWS and ChangeLog [BZ #22774]
      getlogin_r: switch Linux variant to struct scratch_buffer
      elf: Remove ad-hoc restrictions on dlopen callers [BZ #22787]
      ldconfig: Sync temporary files to disk before renaming them [BZ #20890]
      nptl: Move pthread_atfork to libc_nonshared.a
      nptl: Drop libpthread_nonshared.a from libpthread.so
      nptl: Turn libpthread.so into a symbolic link to the real DSO
      malloc: Revert sense of prev_inuse in comments
      Linux i386: tst-bz21269 triggers SIGBUS on some kernels
      support_format_addrinfo: Include unknown error number in result
      inet: Actually build and run tst-deadline
      manual: Move mbstouwcs to an example C file
      manual: Various fixes to the mbstouwcs example, and mbrtowc update
      resolv: Fully initialize struct mmsghdr in send_dg [BZ #23037]
      sunrpc: Remove stray exports without --enable-obsolete-rpc [BZ #23166]
      time: Use 64-bit time values for time zone parsing
      math: Merge strtod_nan_*.h into math-type-macros-*.h
      support: Add TEST_COMPARE_BLOB, support_quote_blob
      math: Reverse include order in <math-type-macros-*.h>
      i386: Drop -mpreferred-stack-boundary=4
      Implement allocate_once for atomic initialization with allocation
      Switch IDNA implementation to libidn2 [BZ #19728] [BZ #19729] [BZ #22247]
      Add references to CVE-2017-18269, CVE-2018-11236, CVE-2018-11237
      stdlib: Additional tests need generated locale dependencies
      support: Add wrappers for pthread_barrierattr_t
      libio: Avoid _allocate_buffer, _free_buffer function pointers [BZ #23236]
      Remove sysdeps/generic/libcidn.abilist
      math: Update i686 ulps
      math: Update i686 ulps (--disable-multi-arch configuration)
      x86: Make strncmp usable from rtld
      scripts/update-abilist.sh: Accept empty list of files to patch
      localedata: Make IBM273 compatible with ISO-8859-1 [BZ #23290]
      Linux: Create Netlink socket with SOCK_CLOEXEC in __check_pf [BZ #15722]
      libio: Avoid ptrdiff_t overflow in IO_validate_vtable
      math: Set 387 and SSE2 rounding mode for tgamma on i386 [BZ #23253]
      nscd restart: Use malloc instead of extend_alloca [BZ #18023]
      nscd: Use struct scratch_buffer, not extend_alloca in most caches [BZ #18023]
      nscd: Switch to struct scratch_buffer in adhstaiX [BZ #18023]
      getgrent_next_nss (compat-initgroups): Remove alloca fallback [BZ #18023]
      _nss_nis_initgroups_dyn: Use struct scratch_buffer [BZ #18023]
      getent: Use dynarray in initgroups_keys [BZ #18023]
      nss_files: Use struct scratch_buffer instead of extend_alloca [BZ #18023]
      libio: Disable vtable validation in case of interposition [BZ #23313]
      support: Add TEST_NO_SETVBUF
      libio: Add tst-vtables, tst-vtables-interposed
      sunrpc: Remove always-defined _RPC_THREAD_SAFE_ macro
      Run thread shutdown functions in an explicit order
      wordexp: Rewrite parse_tilde to use struct scratch_buffer [BZ #18023]
      gethostid (Linux variant): Switch to struct scratch_buffer [BZ #18023]
      _dl_map_object_deps: Use struct scratch_buffer [BZ #18023]
      Remove macros extend_alloca, extend_alloca_account [BZ #18023]
      Use _STRUCT_TIMESPEC as guard in <bits/types/struct_timespec.h> [BZ #23349]
      malloc: Update heap dumping/undumping comments [BZ #23351]
      stdio-common/tst-printf.c: Remove part under a non-free license [BZ #23363]
      testrun.sh: Implement --tool=strace, --tool=valgrind
      Add renameat2 function [BZ #17662]
      Compile debug/stack_chk_fail_local.c with stack protector
      Build csu/elf-init.c and csu/static-reloc.c with stack protector
      conform/conformtest.pl: Escape literal braces in regular expressions
      libio: Implement internal function __libc_readline_unlocked
      nss_files: Fix re-reading of long lines [BZ #18991]
      Fix copyright years in recent commits
      regexec: Fix off-by-one bug in weight comparison [BZ #23036]
      Add the statx function
      Install <bits/statx.h> header
      nptl: Use __mprotect consistently for _STACK_GROWS_UP
      regcomp: Fix off-by-one bug in build_equiv_class [BZ #23396]
      sh: Do not define __ASSUME_STATX
      alpha: mlock2, copy_file_range syscalls were introduced in kernel 4.13
      C11 threads: Fix timeout and locking issues
      htl: Use weak aliases for public symbols

Flávio Cruz (1):
      hurd: Define and pass UTIME_NOW and UTIME_OMIT to new file_utimens RPC

Francois Goichon (1):
      malloc: harden removal from unsorted list

Gabriel F. T. Gomes (3):
      powerpc64*: fix the order of implied sysdeps directories
      Fix parameter type in C++ version of iseqsig (bug 23171)
      ldbl-128ibm-compat: Add printf_size

H.J. Lu (76):
      sparc: Check PIC instead of SHARED in start.S [BZ #22638]
      x86-64: Use __glibc_likely/__glibc_likely in dl-machine.h
      Add a missing ChangeLog item in commit 371b220f620
      Fix a typo in ChangeLog entry
      i386: Use __glibc_likely/__glibc_likely in dl-machine.h
      Add DT_SYMTAB_SHNDX from gABI
      Use ADDRIDX with DT_GNU_HASH
      Define GEN_AS_CONST_HEADERS when generating header files [BZ #22792]
      Fix a typo in ChangeLog (bit_cpu_BIT -> bit_cpu_IBT)
      Fix a typo in ChangeLog: auch_fork -> arch_fork
      Remove hidden __libc_longjmp
      Add $(tests-execstack-$(have-z-execstack)) after defined [BZ #22998]
      Update RWF_SUPPORTED for Linux kernel 4.16 [BZ #22947]
      x86: Use pad in pthread_unwind_buf to preserve shadow stack register
      x86-64/setcontext: Pop the pointer into %rdx after syscall
      cl
      x86-64/swapcontext: Restore the pointer into %rdx after syscall
      x86-64/memset: Mark the debugger symbol as hidden
      x86-64: Remove the unnecessary testl in strlen-avx2.S
      x86: Add sysdeps/x86/ldsodefs.h
      i386: Replace PREINIT_FUNCTION@PLT with *%eax in call
      x86-64: Use IFUNC strncat inside libc.so
      nptl: Remove __ASSUME_PRIVATE_FUTEX
      Initial Fast Short REP MOVSB (FSRM) support
      x86-64: Check Prefer_FSRM in ifunc-memmove.h
      Add a test case for [BZ #23196]
      x86-64: Skip zero length in __mem[pcpy|move|set]_erms
      static-PIE: Update DT_DEBUG for debugger [BZ #23206]
      Mark _init and _fini as hidden [BZ #23145]
      i386: Change offset of __private_ss to 0x30 [BZ #23250]
      benchtests: Add -f/--functions argument
      x86: Rename __glibc_reserved1 to feature_1 in tcbhead_t [BZ #22563]
      x86: Support shadow stack pointer in setjmp/longjmp
      x86_64: Undef SHADOW_STACK_POINTER_OFFSET last
      x86: Support IBT and SHSTK in Intel CET [BZ #21598]
      x86: Always include <dl-cet.h>/cet-tunables.h> for --enable-cet
      x86: Add _CET_ENDBR to functions in crti.S
      x86: Add _CET_ENDBR to functions in dl-tlsdesc.S
      x86-64: Add _CET_ENDBR to STRCMP_SSE42
      i386: Add _CET_ENDBR to indirect jump targets in add_n.S/sub_n.S
      x86_64: Use _CET_NOTRACK in strcmp.S
      x86-64: Use _CET_NOTRACK in strcpy-sse2-unaligned.S
      x86-64: Use _CET_NOTRACK in strcmp-sse42.S
      x86-64: Use _CET_NOTRACK in memcpy-ssse3-back.S
      x86-64: Use _CET_NOTRACK in memcpy-ssse3.S
      i386: Use _CET_NOTRACK in i686/memcmp.S
      i386: Use _CET_NOTRACK in memset-sse2.S
      i386: Use _CET_NOTRACK in memcmp-sse4.S
      i386: Use _CET_NOTRACK in memcpy-ssse3-rep.S
      i386: Use _CET_NOTRACK in memcpy-ssse3.S
      i386: Use _CET_NOTRACK in strcpy-sse2.S
      i386: Use _CET_NOTRACK in strcat-sse2.S
      i386: Use _CET_NOTRACK in memset-sse2-rep.S
      x86-64: Use _CET_NOTRACK in memcmp-sse4.S
      Intel CET: Document --enable-cet
      x86/CET: Document glibc.tune.x86_ibt and glibc.tune.x86_shstk
      INSTALL: Add a note for Intel CET status
      x86-64: Add endbr64 to tst-quadmod[12].S
      x86: Update vfork to pop shadow stack
      Add <bits/indirect-return.h>
      x86/CET: Extend arch_prctl syscall for CET control
      x86: Rename __glibc_reserved2 to ssp_base in tcbhead_t
      x86/CET: Add tests with legacy non-CET shared objects
      Add a test for multiple makecontext calls
      Add another test for setcontext
      Add a test for multiple setcontext calls
      Add tests for setcontext on the context from makecontext
      x86-64/CET: Extend ucontext_t to save shadow stack
      x86/CET: Add a setcontext test for CET
      ia64: Work around incorrect type of IA64 uc_sigmask
      x86: Correct index_cpu_LZCNT [BZ # 23456]
      x86: Populate COMMON_CPUID_INDEX_80000001 for Intel CPUs [BZ #23459]
      Add the missing ChangeLog entry for commit be525a69a66
      x86/CET: Don't parse beyond the note end
      x86: Add tst-get-cpu-features-static to $(tests) [BZ #23458]
      x86/CET: Fix property note parser [BZ #23467]

Herman ten Brugge (1):
      Fix sign of NaN returned by strtod (bug 23007).

Hongbo Zhang (1):
      aarch64: add HXT Phecda core memory operation ifuncs

Igor Gnatenko (1):
      Linux: use reserved name __key in pkey_get [BZ #22797]

Jesse Hathaway (1):
      getlogin_r: return early when linux sentinel value is set

John David Anglin (2):
      Fix ulps for pow on hppa.
      The hppa-linux target still requires an executable stack for kernel

Joseph Myers (110):
      Do not use packed structures in soft-fp.
      Fix m68k bits/fenv.h for no-FPU ColdFire.
      Add ColdFire math-tests.h.
      Move some fenv.h override macros to generic math_private.h.
      Move fenv.h override inline functions to generic math_private.h.
      Add feholdexcept inline in generic math_private.h.
      Remove some math_private.h libc_fe* overrides.
      Remove some math_private.h libc_feholdexcept_setround overrides.
      Move LDBL_CLASSIFY_COMPAT to its own header.
      Update syscall-names.list for 4.15.
      Add MAP_SHARED_VALIDATE from Linux 4.15.
      Add MAP_SYNC from Linux 4.15.
      Add elf.h NT_* macros from Linux 4.15 (bug 14890).
      Add IPV6_FREEBIND from Linux 4.15.
      Add TCP_FASTOPEN_KEY, TCP_FASTOPEN_NO_COOKIE from Linux 4.15.
      Only define loff_t for __USE_MISC (bug 14553).
      Use xmalloc in tst-setcontext-fpscr.c (bug 19668).
      Correct type of SSIZE_MAX for 32-bit (bug 13575).
      Move string/testcopy.c to test-driver.c and xmalloc (bug 19667).
      Fix non-__GNUC__ definitions of __inline and __restrict (bug 17721).
      Unify and simplify bits/byteswap.h, bits/byteswap-16.h headers (bug 14508, bug 15512, bug 17082, bug 20530).
      Fix -Os strcoll, wcscoll, build (bug 21313).
      Fix -Os gnu_dev_* linknamespace, localplt issues (bug 15105, bug 19463).
      Use MPFR 4.0.1 in build-many-glibcs.py.
      Define char16_t, char32_t consistently with uint_least16_t, uint_least32_t (bug 17979).
      Remove unused math/Makefile variable libm-test-incs.
      Add build infrastructure for narrowing libm functions.
      Add test infrastructure for narrowing libm functions.
      Handle narrowing function sNaN test disabling based on argument format.
      Fix narrowing function tests build for powerpc64le.
      Add narrowing add functions.
      Fix -Os feof_unlocked linknamespace, localplt issues (bug 15105, bug 19463).
      Use libc_hidden_* for fputs (bug 15105).
      Use libc_hidden_* for __cmsg_nxthdr (bug 15105).
      Use libc_hidden_* for argz_next, __argz_next (bug 15105).
      Fix hppa local PLT entries for sigprocmask (bug 18124).
      Document use of CC and CFLAGS in more detail (bug 20980, bug 21234).
      Fix -Os ferror_unlocked linknamespace, localplt issues (bug 15105, bug 19463).
      Fix -Os getc_unlocked linknamespace, localplt issues (bug 15105, bug 19463).
      Fix -Os putc_unlocked, fputc_unlocked linknamespace, localplt issues (bug 15105, bug 19463).
      Use libc_hidden_* for tolower, toupper (bug 15105).
      Use libc_hidden_* for atoi (bug 15105).
      Fix another -Os strcoll build issue.
      Fix two more -Os strcoll / wcscoll build failures.
      Use libc_hidden_* for strtoumax (bug 15105).
      Fix i386 fenv_private.h float128 for 32-bit --with-fpmath=sse (bug 22902).
      Fix powerpc ifunc-sel.h build for -Os.
      Fix s390 -Os iconv build.
      Remove old-GCC parts of x86 bits/mathinline.h.
      Remove more old-compilers parts of sysdeps/x86/fpu/bits/mathinline.h.
      Update i386 libm-test-ulps.
      Remove sysdeps/x86/fpu/bits/mathinline.h __finite inline.
      Add SHT_X86_64_UNWIND to elf.h (bug 20079).
      Add narrowing subtract functions.
      Fix signed integer overflow in random_r (bug 17343).
      Remove powerpc, sparc fdim inlines (bug 22987).
      Use x86_64 backtrace as generic version.
      Remove unused frame.h header, sigcontextinfo.h macros.
      Unify umount function implementations (bug 16552).
      Use Linux 4.16 in build-many-glibcs.py.
      Make build-many-glibcs.py build GCC for powerpcspe with --enable-obsolete.
      Update aarch64 bits/hwcap.h, dl-procinfo.c for Linux 4.16 HWCAP_ASIMDFHM.
      Define XTABS to TAB3 on alpha to match Linux 4.16.
      Add NT_PPC_PKEY from Linux 4.16 to elf.h.
      Add PTRACE_SECCOMP_GET_METADATA from Linux 4.16 to sys/ptrace.h.
      Fix Hurd glibc build with GCC 8.
      Use GCC 8 in build-many-glibcs.py by default.
      Remove tilegx port.
      Ignore absolute symbols in ABI tests.
      Move math_narrow_eval to separate math-narrow-eval.h.
      Move math_opt_barrier, math_force_eval to separate math-barriers.h.
      Move math_check_force_underflow macros to separate math-underflow.h.
      Do not include math-barriers.h in math_private.h.
      Add narrowing multiply functions.
      Update MIPS libm-test-ulps.
      Add narrowing divide functions.
      Fix year 2039 bug for localtime with 64-bit time_t (bug 22639).
      Obsolete nfsservctl.
      Split test-tgmath3 by function.
      Make llseek a compat symbol (bug 18471).
      Fix i686-linux-gnu build with GCC mainline.
      Remove sysdeps/aarch64/soft-fp directory.
      Remove sysdeps/alpha/soft-fp directory.
      Remove sysdeps/sh/soft-fp directory.
      Remove sysdeps/powerpc/soft-fp directory.
      Remove sysdeps/sparc/sparc32/soft-fp directory.
      Remove sysdeps/sparc/sparc64/soft-fp directory.
      Make powerpc-nofpu __sqrtsf2, __sqrtdf2 compat symbols (bug 18473).
      Use Linux 4.17 in build-many-glibcs.py.
      Update kernel version in syscall-names.list to 4.17.
      Add MAP_FIXED_NOREPLACE from Linux 4.17 to bits/mman.h.
      Add AArch64 hwcap values from Linux 4.17.
      Fix ldbl-96 fma (Inf, Inf, finite) (bug 23272).
      Do not use const attribute for nan functions (bug 23277).
      Fix strtod overflow detection (bug 23279).
      Ignore -Wrestrict for one strncat test.
      Add tests for sign of NaN returned by strtod (bug 23007).
      Fix powerpc64le build of nan-sign tests (bug 23303).
      Update MAP_TYPE value for hppa from Linux 4.17.
      Add MSG_STAT_ANY from Linux 4.17 to bits/msq.h.
      Add SEM_STAT_ANY from Linux 4.17 to bits/sem.h.
      Add SHM_STAT_ANY from Linux 4.17 to bits/shm.h.
      Fix scanf rounding of negative floating-point numbers (bug 23280).
      Fix bug-strspn1.c, bug-strpbrk1.c build with GCC mainline.
      Fix tst-cmp.c build with GCC mainline.
      Fix hardcoded /tmp paths in testing (bug 13888).
      Remove nptl/sockperf.c.
      Avoid insecure usage of tmpnam in tests.
      Use binutils 2.31 branch in build-many-glibcs.py.
      Update powerpc-nofpu ulps.

Leonardo Sandoval (6):
      x86-64: remove duplicate line on PREFETCH_ONE_SET macro
      Add missing changelog from previous commit
      x86-64: Optimize strcmp/wcscmp and strncmp/wcsncmp with AVX2
      benchtests: Add --no-diff and --no-header options
      benchtests: Catch exceptions in input arguments
      benchtests: improve argument parsing through argparse library

Maciej W. Rozycki (6):
      nptl_db: Remove stale `match_pid' parameter from `iterate_thread_list'
      elf: Unify symbol address run-time calculation [BZ #19818]
      elf: Correct absolute (SHN_ABS) symbol run-time calculation [BZ #19818]
      nisplus: Correct pwent parsing issue and resulting build error [BZ #23266]
      elf: Accept absolute (SHN_ABS) symbols whose value is zero [BZ #23307]
      libc-abis: Define ABSOLUTE ABI [BZ #19818][BZ #23307]

Mark Wielaard (1):
      elf.h: Add BPF relocation types.

Martin Sebor (1):
      Document interaction with GCC built-ins in the Customizing Printf

Michael Wolf (1):
      New locale: Lower Sorbian (dsb_DE) [BZ #23208]

Mike FABIAN (23):
      Add missing “reorder-end” in LC_COLLATE of et_EE [BZ #22517]
      Use “copy "es_BO"” in LC_TIME of es_CU, es_CL, and es_EC
      Use / instead of - in d_fmt for pt_BR and pt_PT [BZ #17438]
      Remove --quiet argument when installing locales
      Update iso14651_t1_common file to ISO14651_2016_TABLE1_en.txt [BZ #14095]
      Necessary changes after updating the iso14651_t1_common file
      iso14651_t1_common: <U\([0-9A-F][0-9A-F][0-9A-F][0-9A-F][0-9A-F]\)> → <U000\1>
      Fixing syntax errors after updating the iso14651_t1_common file
      Add convenience symbols like <AFTER-A>, <BEFORE-A> to iso14651_t1_common
      iso14651_t1_common: make the fourth level the codepoint for characters which are ignorable on all 4 levels
      Add sections for various scripts to the iso14651_t1_common file
      Collation order of ȥ has changed in new iso14651_t1_common file, adapt test files
      Collation order of @-. and space has changed in new iso14651_t1_common file, adapt test files
      Fix posix/bug-regex5.c test case, adapt to iso14651_t1_common upate
      Fix test cases tst-fnmatch and tst-regexloc for the new iso14651_t1_common file.
      Improve gen-locales.mk and gen-locale.sh to make test files with @ options work
      Adapt collation in several locales to the new iso14651_t1_common file
      Remove the lines from cmn_TW.UTF-8.in which cannot work at the moment.
      bg_BG locale: Fix a typo in a comment
      an_ES locale: update some locale data [BZ #22896]
      Fix tst-strfmon_l test for hr_HR locale
      Bug 23308: Update to Unicode 11.0.0
      Put the correct Unicode version number 11.0.0 into the generated files

Patrick McGehearty (1):
      Improves __ieee754_exp(x) performance by 18-37% when |x| < 1.0397

Patsy Franklin (1):
      In sem_open.c,  pad was not initialized when __HAVE_64B_ATOMICS was

Paul Pluzhnikov (3):
      Fix BZ 20419.  A PT_NOTE in a binary could be arbitratily large, so using
      Fix BZ 22786: integer addition overflow may cause stack buffer overflow
      Update ulps with "make regen-ulps" on AMD Ryzen 7 1800X.

Quentin PAGÈS (1):
      oc_FR locale: Multiple updates (bug 23140, bug 23422).

Rafal Luzynski (13):
      lt_LT locale: Update abbreviated month names (bug 22932).
      Greek (el_CY, el_GR) locales: Introduce ab_alt_mon (bug 22937).
      cs_CZ locale: Add alternative month names (bug 22963).
      NEWS: Mention the locale data changes (bug 22848, 22937, 22963).
      gd_GB: Fix typo in abbreviated "May" (bug 23152).
      gd_GB, hsb_DE, wa_BE: Add alternative month names (bug 23140).
      csb_PL: Update month translations + add yesstr/nostr (bug 19485).
      csb_PL: Add alternative month names (bug 23140).
      ast_ES: Add alternative month names (bug 23140).
      hy_AM: Add alternative month names (bug 23140).
      dsb_DE locale: Fix syntax error and add tests (bug 23208).
      os_RU: Add alternative month names (bug 23140).
      NEWS: Avoid the words "nominative" and "genitive".

Rajalakshmi Srinivasaraghavan (3):
      powerpc: Add multiarch sqrtf128 for ppc64le
      ldbl-128ibm-compat: Introduce ieee128 symbols
      Add long double input for strfmon test

Raymond Nicholson (1):
      manual/startup.texi (Aborting a Program): Remove inappropriate joke.

Rical Jasan (9):
      manual: Fix Texinfo warnings about improper node names.
      manual: Fix a syntax error.
      manual: Improve documentation of get_current_dir_name. [BZ #6889]
      manual: Document missing feature test macros.
      manual: Update the _ISOC99_SOURCE description.
      manual: Update _DEFAULT_SOURCE.  [BZ #22862]
      Fix a typo in a comment.
      Add [BZ #16335] annotation to ChangeLog entry.
      Add manual documentation for threads.h

Richard Braun (1):
      Hurd: fix port leak in TLS

Robert Buj (1):
      ca_ES locale: Update LC_TIME (bug 22848).

Rogerio Alves (1):
      powerpc64: Always restore TOC on longjmp [BZ #21895]

Samuel Thibault (131):
      hurd: Fix build
      nscd: don't unconditionally use PTHREAD_RWLOCK_WRITER_NONRECURSIVE_INITIALIZER_NP
      hurd: Define EXEC_PAGESIZE
      hurd: Fix build on missing __ptsname_internal function
      hurd: fix build
      hurd: Add sysdep-cancel.h
      Move NPTL-specific code to NPTL-specific header
      hurd: fix timer_routines.c build
      hurd: fix gai_misc build
      hurd: fix timer_routines.c build
      hurd: do not check Mach and Hurd headers
      hurd: Add missing includes
      hurd: Add missing includes
      hurd: Move mach/param.h to bits/mach/param.h
      hurd: avoid including hurd/signal.h when not needed
      hurd: fix header conformity
      hurd: Add missing include
      hurd: Avoid using ino64_t and loff_t in headers
      hurd: Fix inclusion of mach headers in all standards
      hurd: Make almost all hurd headers includable in all standards
      Separate out error_t definition
      hurd: Add futimens support
      hurd: Fix includability of <hurd/signal.h> in all standards
      hurd: Add futimesat and utimensat support
      Add missing start-of-file descriptive comment.
      hurd: add gscope support
      hurd: add TLS support
      hurd: Fix getting signal thread stack layout for fork
      hurd: Replace threadvars with TLS
      hurd: Fix link cthread/pthread symbol exposition.
      hurd: Fix coding style
      x86_64: Fix build with RTLD_PRIVATE_ERRNO defined to 1
      hurd: Add missing include
      hurd: Fix copyright years
      hurd: Fix O_NOFOLLOW
      hurd: Fix O_DIRECTORY | O_NOFOLLOW
      hurd: Fix boot with statically-linked exec server
      hurd: Add mlockall support
      hurd: fix build
      hurd: Fix build with latest htl
      hurd: Code style fixes
      Fix errno values
      hurd: Fix accessing errno from rtld
      hurd: Initialize TLS and libpthread before signal thread start
      Add missing changelog from previous commit
      hurd: Fix calling __pthread_initialize_minimal in shared case
      hurd: Regenerate errno.h header
      hurd: advertise process memory locking option
      hurd: avoid letting signals go to thread created by timer_create
      hurd: Add hurd thread library
      hurd libpthread: add function missing in ABI list
      hurd: Advertise libpthread
      hurd: Remove bogus net/if_ppp.h
      hurd: Bump remaining LGPL2+ htl licences to LGPL 2.1+
      hurd: Announce that glibc now builds unpatched
      hurd: Fix exposition of UTIME_NOW, UTIME_OMIT
      hurd: Avoid local PLTs in libpthread.
      hurd: Avoid some PLTs in libc and librt
      Revert __dirfd PLT avoidance for now
      hurd: whitelist rtld symbols expected to be overridable
      hurd: Add __errno_location to overridable ld.so symbols
      hurd: Update localplt.data
      hurd: whitelist ld.so PLTs supposed to be avoided by rtld_hidden
      hurd: Avoid some libc.so PLTs
      hurd: Avoid more libc.so PLTs
      hurd: Fix typo
      hurd: Avoid more libc.so local PLTs
      hurd: Avoid local PLT in libpthread
      s390x: Fix hidden aliases
      hurd: Fix buffer overrun in __if_nametoindex
      Revert "s390x: Fix hidden aliases"
      Revert parts of "hurd: Avoid more libc.so local PLTs"
      hurd: Make __if_nametoindex return ENODEV if ifname is too long
      hurd: Fix missing trailing NUL in __if_nametoindex
      hurd: Silence warning
      hurd: Add missing symbols
      hurd: fix build
      hurd: Fix typo
      hurd: Avoid PLTs for longjmp & siglongjmp
      hurd: Avoid PLT for dirfd
      Revert "hurd: Avoid PLTs for longjmp & siglongjmp"
      hurd: fix conformity test for sys/un.h
      hurd: Fix spurious installation of headers defining hidden prototypes
      Fix sched_param
      conform sys/un.h: Allow sun_ prefix, not only sun_len
      Revert "Fix sched_param"
      hurd: Fix mach installed headers test
      hurd: xfail some structure fields ABI incompatibility with standards
      hurd: Fix standard compliance of some statvfs fields
      hurd: Update struct statfs according to struct statvfs
      hurd: Fix symbols exposition
      hurd: Avoid exposing all <sched.h> symbols from sys/types.h
      hurd: fix sigevent's sigev_notify_attributes field type
      hurd: remove non-standard siginfo symbol
      hurd: Fix termios.h symbols
      hurd: Add missing RLIM_SAVED_MAX/CUR
      hurd: Fix hurd installed headers test
      Drop fpregset unused symbol exposition
      Revert "hurd: Fix mach installed headers test"
      hurd: XFAIL appearance of sched_param and sched_priority from <sys/types.h>
      hurd: XFAIL tests for signal features not implemented yet
      hurd xfails: Add missing bug references
      hurd: Fix shmid_ds's shm_segsz field type
      hurd: xfail missing abilist for libmachuser and libhurduser
      hurd: update localplt.data
      hurd: Avoid PLTs for _hurd_port_locked_get/set
      hurd: Avoid PLTs for __mach_thread_self and __mach_reply_port
      hurd: Avoid a PLT reference
      hurd: Fix htl link failure
      hurd: avoid PLT ref between sendfile and sendfile64
      hurd: Detect 32bit overflow in value returned by lseek
      hurd: Avoid PLT ref for __pthread_get_cleanup_stack
      hurd: Avoid missing PLT ref from ld.so requirement
      hurd: Avoid PLT references to shortcuts
      hurd: Avoid PLT ref to __mach_msg
      hurd: Avoid PLT references to syscalls
      hurd: Whitelist PLT refs which are difficult to avoid
      hurd: Fix missing __pthread_get_cleanup_stack symbol
      hurd: Fix reference to _hurd_self_sigstate
      hurd: Fix "Missing required PLT reference"
      hurd: fix localplt.data format
      hurd: Enable thread-safe i386 atomic instructions
      Fix new file header
      hurd: Fix installed-headers tests
      check-execstack: Permit sysdeps to xfail some libs
      hurd: Fix some ld.so symbol override from libc
      hurd: Fix some ld.so symbol override from libc
      hurd: Fix some ld.so symbol override from libc
      hurd: Fix startup of static binaries linked against libpthread
      hurd: Add missing ChangeLog entry
      hurd: Fix exec usage of mach_setup_thread

Sean McKean (1):
      time: Reference CLOCKS_PER_SEC in clock comment [BZ #22735]

Siddhesh Poyarekar (18):
      benchtests: Reallocate buffers for every test run
      benchtests: Make bench-memcmp print json
      aarch64: Use the L() macro for labels in memcmp
      aarch64/strcmp: fix misaligned loop jump target
      benchtests: Convert strncmp benchmark output to json
      benchtests: Reallocate buffers for every strncmp implementation
      benchtests: Don't benchmark 0 length calls for strncmp
      Add ChangeLog entry for last 3 commits
      aarch64: Optimized memcmp for medium to large sizes
      aarch64: Fix branch target to loop16
      aarch64: Improve strncmp for mutually misaligned inputs
      aarch64/strncmp: Unbreak builds with old binutils
      aarch64/strncmp: Use lsr instead of mov+lsr
      benchtests: Move iterator declaration into loop header
      aarch64,falkor: Ignore prefetcher hints for memmove tail
      aarch64,falkor: Ignore prefetcher tagging for smaller copies
      aarch64,falkor: Use vector registers for memmove
      aarch64,falkor: Use vector registers for memcpy

Stefan Liebler (9):
      S390: Regenerate ULPs.
      Add runtime check if mutex will be elided in tst-mutex8 testcases.
      S390: Regenerate ULPs.
      S390: Regenerate ULPs.
      S390: Fix struct sigaction for 31bit in kernel_sigaction.h.
      Use volatile global counters in test-tgmath.c.
      Disable lock elision for mutex pretty printer tests.
      Fix blocking pthread_join. [BZ #23137]
      Fix string/tst-xbzero-opt if build with gcc head.

Steve Ellcey (2):
      IFUNC for Cavium ThunderX2
      aarch64: Use an ifunc/VDSO to implement gettimeofday in shared glibc.

Sylvain Lesage (1):
      es_BO locale: Change LC_PAPER to en_US (bug 22996).

Szabolcs Nagy (5):
      Remove slow paths from exp
      Fix documentation build with old makeinfo
      Use uint32_t sign in single precision math error handling functions
      aarch64: Remove HWCAP_CPUID from HWCAP_IMPORTANT
      aarch64: add HWCAP_ATOMICS to HWCAP_IMPORTANT

Thomas Schwinge (3):
      hurd: SOCK_CLOEXEC and SOCK_NONBLOCK for socket
      hurd: SOCK_CLOEXEC and SOCK_NONBLOCK for socketpair
      hurd: Implement pipe2

Tulio Magno Quites Machado Filho (14):
      powerpc: Update pow() ULPs
      powerpc: Undefine Linux ptrace macros that conflict with __ptrace_request
      powerpc: Update sin, cos and sincos ULPs
      Increase robustness of internal dlopen() by using RTLD_NOW [BZ #22766]
      Replace M_SUF (fabs) with M_FABS
      Replace M_SUF (M_LN2) with M_MLIT (M_LN2)
      Replace hidden_def with libm_hidden_def in math
      powerpc: Fix the compiler type used with C++ when -mabi=ieeelongdouble
      powerpc: Move around math-related Implies
      powerpc64le: Fix TFtype in sqrtf128 when using -mabi=ieeelongdouble
      Move declare_mgen_finite_alias definition
      Add a generic significand implementation
      ldbl-128ibm-compat: Create libm-alias-float128.h
      m68k: Reorganize log1p and significand implementations

Valery Timiriliyev (1):
      New locale: Yakut (Sakha) for Russia (sah_RU) [BZ #22241]

Vincent Chen (1):
      Add Andes nds32 dynamic relocations to elf.h

Wilco Dijkstra (20):
      Remove slow paths from log
      [AArch64] Use builtins for fpcr/fpsr
      [AArch64] Fix testsuite error due to fpsr/fscr change
      Remove slow paths from pow
      Remove mplog and mpexp
      [AArch64] Fix include.
      Use correct includes in benchtests
      Add support for sqrt asm redirects
      Rename all __ieee754_sqrt(f/l) calls to sqrt(f/l)
      Remove all target specific __ieee754_sqrt(f/l) inlines
      Revert m68k __ieee754_sqrt change
      Undefine attribute_hidden to fix benchtests
      sin/cos slow paths: avoid slow paths for small inputs
      sin/cos slow paths: remove large range reduction
      sin/cos slow paths: remove slow paths from small range reduction
      sin/cos slow paths: remove slow paths from huge range reduction
      sin/cos slow paths: remove unused slowpath functions
      sin/cos slow paths: refactor duplicated code into dosin
      sin/cos slow paths: refactor sincos implementation
      Improve strstr performance

Zack Weinberg (23):
      Remove some unnecessary redefinitions of std symbols.
      Remove getc and putc macros from the public stdio.h.
      Don't install libio.h or _G_config.h.
      Post-cleanup 1: move libio.h back out of bits/.
      Post-cleanup 2: minimize _G_config.h.
      [BZ #22830] malloc_stats: restore cancellation for stderr correctly.
      [BZ #19239] Don't include sys/sysmacros.h from sys/types.h.
      Remove vestiges of external build support from libio headers.
      Mechanically remove _IO_ name aliases for types and constants.
      Remove legacy configuration knobs from libio.
      Remove _IO_file_flags define.
      Remove miscellaneous debris from libio.
      alpha/clone.S: Invoke .set noat/.set at around explicit uses of $at
      Don't include math.h/math_private.h in math_ldbl_opt.h.
      nldbl-compat.c: Include math.h before nldbl-compat.h.
      [BZ 1190] Make EOF sticky in stdio.
      Make sysdeps/generic/internal-signals.h less stubby.
      NEWS: Reindent and copyedit
      Avoid cancellable I/O primitives in ld.so.
      Disallow use of DES encryption functions in new programs.
      manual: Reorganize crypt.texi.
      manual: Revise crypt.texi.
      New configure option --disable-crypt.

Zong Li (1):
      Change URL of gcc's tarball

-----------------------------------------------------------------------